----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    14:07:47 10/07/2013 
-- Design Name: 
-- Module Name:    TCPIP_if - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use IEEE.std_logic_misc.all;
use IEEE.numeric_std.all;
use work.amc13_pack.all;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
library UNISIM;
use UNISIM.VComponents.all;
Library UNIMACRO;
use UNIMACRO.vcomponents.all;

entity TCPIP_if is
    Port ( sysclk : in  STD_LOGIC;
           DRPclk : in  STD_LOGIC;
           reset : in  STD_LOGIC;
           TCPreset : in  STD_LOGIC;
           rstCntr : in  STD_LOGIC;
           test : in  STD_LOGIC;
					 enSFP : IN std_logic_vector(3 downto 0);
					 SFP_down : OUT std_logic_vector(2 downto 0);
           inc_ddr_pa : in  STD_LOGIC;
-- event data in
					 evt_data_rdy : in std_logic_vector(2 downto 0);
--					 evt_buf_space : IN std_logic_vector(2 downto 0); -- '0' if monitor buffer is required
--					 event_size : in array3X13; -- in 64bit words
					 EventData_in : in array3X66;
					 EventData_we : in   std_logic_VECTOR(2 downto 0);
					 EventData_re : out   std_logic_VECTOR(2 downto 0); -- 
					 evt_buf_full : out std_logic_vector(2 downto 0);
					 buf_rqst : in std_logic_vector(1 downto 0);
           MonBuf_avl : out  STD_LOGIC;
					 WrtMonBufAllDone : out  STD_LOGIC;
           TCPBuf_avl : out  STD_LOGIC;
-- ddr wportA status
					 wport_rdy : in std_logic_vector(2 downto 0);
					 WrtMonBufDone : in std_logic_vector(2 downto 0);
					 wport_FIFO_full : in std_logic_vector(2 downto 0);
-- ddr wportB signals in sysclk domain
					 TCP_dout : out std_logic_vector(31 downto 0); -- TCP data are written in unit of 32-bit words
					 TCP_channel : out std_logic_vector(1 downto 0); -- Each entry has four 32bit words, each address saves two entries. Addresses are kept in ddr_wportB
					 TCP_wrqst : out STD_LOGIC;
					 TCP_re	: in STD_LOGIC;
-- ddr rport signals
					 TCP_raddr : out  STD_LOGIC_VECTOR(28 downto 0); -- 28-26 encoded request source 25-0 address in 64 bit word
					 TCP_length	: out  STD_LOGIC_VECTOR(9 downto 0); -- in 64 bit word, actual length - 1
					 TCP_rrqst : out  STD_LOGIC;
					 TCP_rack	: in  STD_LOGIC;
					 TCP_din	: in  STD_LOGIC_VECTOR(31 downto 0); -- TCP data are written in unit of 32-bit words
					 TCP_din_valid	: in  STD_LOGIC;
					 TCP_lastword	: in  STD_LOGIC;
-- signal to ddr_if, AMC_if to start moving data
					 EventBufAddr_we : out std_logic_VECTOR(2 downto 0);
					 EventBufAddr : out array3X17;
-- SFP ports
           SFP0_RXN : in  STD_LOGIC;
           SFP0_RXP : in  STD_LOGIC;
           SFP1_RXN : in  STD_LOGIC;
           SFP1_RXP : in  STD_LOGIC;
           SFP2_RXN : in  STD_LOGIC;
           SFP2_RXP : in  STD_LOGIC;
           SFP0_TXN : out  STD_LOGIC;
           SFP0_TXP : out  STD_LOGIC;
           SFP1_TXN : out  STD_LOGIC;
           SFP1_TXP : out  STD_LOGIC;
           SFP2_TXN : out  STD_LOGIC;
           SFP2_TXP : out  STD_LOGIC;
           SFP_REFCLK_N : in  STD_LOGIC;
           SFP_REFCLK_P : in  STD_LOGIC;
--	ipbus signals
					 ipb_clk : in  STD_LOGIC;
					 ipb_write : in  STD_LOGIC;
					 ipb_strobe : in  STD_LOGIC;
					 ipb_addr	: in  STD_LOGIC_VECTOR(31 downto 0);
					 ipb_wdata : in  STD_LOGIC_VECTOR(31 downto 0);
					 ipb_rdata : out  STD_LOGIC_VECTOR(31 downto 0);
					 ipb_ack : out  STD_LOGIC
					 );
end TCPIP_if;

architecture Behavioral of TCPIP_if is
COMPONENT TCPIP
	generic (simulation : boolean := false; en_KEEPALIVE : std_logic := '0');
	PORT(
		reset : IN std_logic;
    rstCntr : in  STD_LOGIC;
		sysclk : IN std_logic;
		clk2x : IN std_logic;
		clk : IN std_logic;
		strobe_us : IN std_logic;
		strobe_ms : IN std_logic;
		en_LINK : IN std_logic;
--		IP_ID : IN std_logic_vector(15 downto 0);
		MY_PORT : IN std_logic_vector(15 downto 0);
		MY_IP : IN std_logic_vector(31 downto 0);
		MY_ETH : IN std_logic_vector(47 downto 0);
		CWND_max : IN std_logic_vector(31 downto 0);
		TSclock : IN std_logic_vector(31 downto 0);
		EVENTdata : IN std_logic_vector(65 downto 0);
		EventBufAddr : IN std_logic_vector(16 downto 0);
		EventBufAddr_we : IN std_logic;
		AddrBuf_full : OUT std_logic;
		EVENTdata_avl : IN std_logic;
		DDR2TCPdata : IN std_logic_vector(32 downto 0);
		RETXdata_we : IN std_logic_vector(1 downto 0);
		RETXdata_chksum : IN std_logic_vector(15 downto 0);
		re_RETX_ddr_wq_in : IN std_logic;
		RETX_ddr_data_we : IN std_logic;
		RETXdataACK : IN std_logic;
		PhyEmacRxC : IN std_logic_vector(3 downto 0);
		PhyEmacRxD : IN std_logic_vector(31 downto 0);          
		LINK_down : OUT std_logic;
		EVENTdata_re : OUT std_logic;
--		EVENTdata_LEN_re : OUT std_logic;
		RETX_ddr_out : OUT std_logic_vector(31 downto 0);
		RETX_ddr_wrqst : OUT std_logic;
		RETX_ddr_LEN : OUT std_logic_vector(4 downto 0);
		RETX_ddr_rrqst : OUT std_logic;
		RETXdataRqst : OUT std_logic;
--		RETXdata_space : OUT std_logic;
		RETXdataAddr : OUT std_logic_vector(25 downto 0);
		RETXdataLEN : OUT std_logic_vector(10 downto 0);
		UNA_MonBuf : OUT std_logic_vector(12 downto 0);
		UNA_TCPBuf : OUT std_logic_vector(12 downto 0);
--		ReleaseLEN : OUT std_logic_vector(10 downto 0);
--		Release_space : OUT std_logic;
--		ReleaseBuffer : OUT std_logic;
--		Release_rqst : OUT std_logic;
		EmacPhyTxC : OUT std_logic_vector(3 downto 0);
		EmacPhyTxD : OUT std_logic_vector(31 downto 0);
		ipb_addr	: in  STD_LOGIC_VECTOR(31 downto 0);
		ipb_rdata : out  STD_LOGIC_VECTOR(31 downto 0);
		csa : OUT std_logic_vector(135 downto 0);
		csb : OUT std_logic_vector(135 downto 0)
		);
END COMPONENT;
COMPONENT XGbEPCS32
	PORT(
			 reset : IN  std_logic;
			 clk2x : IN  std_logic;
			 clk : IN  std_logic;
			 TXUSRCLK : IN  std_logic;
			 TX_high : IN  std_logic;
			 RXUSRCLK : IN  std_logic;
			 RXRESETDONE : IN std_logic;
			 inh_TX : IN std_logic;
			 RESET_TXSync : IN std_logic;
			 GTX_TXD : OUT  std_logic_vector(31 downto 0);
			 GTX_TXHEADER : OUT  std_logic_vector(1 downto 0);
			 GTX_TX_PAUSE : IN  std_logic;
			 GTX_RXD : IN  std_logic_vector(31 downto 0);
			 GTX_RXDVLD : IN  std_logic;
			 GTX_RXHEADER : IN  std_logic_vector(1 downto 0);
			 GTX_RXHEADERVLD : IN  std_logic;
			 GTX_RXGOOD : OUT  std_logic;
			 GTX_RXGEARBOXSLIP_OUT : OUT  std_logic;
			 EmacPhyTxC : IN  std_logic_vector(3 downto 0);
			 EmacPhyTxD : IN  std_logic_vector(31 downto 0);
			 PhyEmacRxC : OUT  std_logic_vector(3 downto 0);
			 PhyEmacRxD : OUT  std_logic_vector(31 downto 0)
			);
END COMPONENT;
component SFP3_init
generic
(
    -- Simulation attributes
    EXAMPLE_SIM_GTRESET_SPEEDUP    : string    := "FALSE";    -- Set to 1 to speed up sim reset
    EXAMPLE_SIMULATION             : integer   := 0;          -- Set to 1 for simulation
    EXAMPLE_USE_CHIPSCOPE          : integer   := 0           -- Set to 1 to use Chipscope to drive resets

);
port
(
    SYSCLK_IN                               : in   std_logic;
    SOFT_RESET_IN                           : in   std_logic;
    DONT_RESET_ON_DATA_ERROR_IN             : in   std_logic;
    GT0_TX_FSM_RESET_DONE_OUT               : out  std_logic;
    GT0_RX_FSM_RESET_DONE_OUT               : out  std_logic;
    GT0_DATA_VALID_IN                       : in   std_logic;
    GT1_TX_FSM_RESET_DONE_OUT               : out  std_logic;
    GT1_RX_FSM_RESET_DONE_OUT               : out  std_logic;
    GT1_DATA_VALID_IN                       : in   std_logic;
    GT2_TX_FSM_RESET_DONE_OUT               : out  std_logic;
    GT2_RX_FSM_RESET_DONE_OUT               : out  std_logic;
    GT2_DATA_VALID_IN                       : in   std_logic;

    --_________________________________________________________________________
        --GT0  (X1Y12)
    --____________________________CHANNEL PORTS________________________________
    ---------------------------- Channel - DRP Ports  --------------------------
    GT0_DRPADDR_IN                          : in   std_logic_vector(8 downto 0);
    GT0_DRPCLK_IN                           : in   std_logic;
    GT0_DRPDI_IN                            : in   std_logic_vector(15 downto 0);
    GT0_DRPDO_OUT                           : out  std_logic_vector(15 downto 0);
    GT0_DRPEN_IN                            : in   std_logic;
    GT0_DRPRDY_OUT                          : out  std_logic;
    GT0_DRPWE_IN                            : in   std_logic;
    ------------------------------- Loopback Ports -----------------------------
    GT0_LOOPBACK_IN                         : in   std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    GT0_RXUSERRDY_IN                        : in   std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    GT0_EYESCANDATAERROR_OUT                : out  std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    GT0_RXCDRLOCK_OUT                       : out  std_logic;
    ------------------ Receive Ports - FPGA RX Interface Ports -----------------
    GT0_RXUSRCLK_IN                         : in   std_logic;
    GT0_RXUSRCLK2_IN                        : in   std_logic;
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    GT0_RXDATA_OUT                          : out  std_logic_vector(31 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    GT0_RXPRBSERR_OUT                       : out  std_logic;
    GT0_RXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    GT0_RXPRBSCNTRESET_IN                   : in   std_logic;
    --------------------------- Receive Ports - RX AFE -------------------------
    GT0_GTXRXP_IN                           : in   std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    GT0_GTXRXN_IN                           : in   std_logic;
    ------------------- Receive Ports - RX Buffer Bypass Ports -----------------
    GT0_RXBUFRESET_IN                       : in   std_logic;
    GT0_RXBUFSTATUS_OUT                     : out  std_logic_vector(2 downto 0);
    --------------- Receive Ports - RX Fabric Output Control Ports -------------
    GT0_RXOUTCLK_OUT                        : out  std_logic;
    ---------------------- Receive Ports - RX Gearbox Ports --------------------
    GT0_RXDATAVALID_OUT                     : out  std_logic;
    GT0_RXHEADER_OUT                        : out  std_logic_vector(1 downto 0);
    GT0_RXHEADERVALID_OUT                   : out  std_logic;
    --------------------- Receive Ports - RX Gearbox Ports  --------------------
    GT0_RXGEARBOXSLIP_IN                    : in   std_logic;
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    GT0_GTRXRESET_IN                        : in   std_logic;
    GT0_RXPMARESET_IN                       : in   std_logic;
    ------------------ Receive Ports - RX Margin Analysis ports ----------------
    GT0_RXLPMEN_IN                          : in   std_logic;
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    GT0_RXRESETDONE_OUT                     : out  std_logic;
    ------------------------ TX Configurable Driver Ports ----------------------
    GT0_TXPOSTCURSOR_IN                     : in   std_logic_vector(4 downto 0);
    GT0_TXPRECURSOR_IN                      : in   std_logic_vector(4 downto 0);
    --------------------- TX Initialization and Reset Ports --------------------
    GT0_GTTXRESET_IN                        : in   std_logic;
    GT0_TXUSERRDY_IN                        : in   std_logic;
    ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
    GT0_TXUSRCLK_IN                         : in   std_logic;
    GT0_TXUSRCLK2_IN                        : in   std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    GT0_TXDIFFCTRL_IN                       : in   std_logic_vector(3 downto 0);
    GT0_TXINHIBIT_IN                        : in   std_logic;
    GT0_TXMAINCURSOR_IN                     : in   std_logic_vector(6 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT0_TXDATA_IN                           : in   std_logic_vector(31 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT0_GTXTXN_OUT                          : out  std_logic;
    GT0_GTXTXP_OUT                          : out  std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    GT0_TXOUTCLK_OUT                        : out  std_logic;
    GT0_TXOUTCLKFABRIC_OUT                  : out  std_logic;
    GT0_TXOUTCLKPCS_OUT                     : out  std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    GT0_TXHEADER_IN                         : in   std_logic_vector(1 downto 0);
    GT0_TXSEQUENCE_IN                       : in   std_logic_vector(6 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    GT0_TXRESETDONE_OUT                     : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT0_TXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
   
    --_________________________________________________________________________
        --GT1  (X1Y13)
    --____________________________CHANNEL PORTS________________________________
    ---------------------------- Channel - DRP Ports  --------------------------
    GT1_DRPADDR_IN                          : in   std_logic_vector(8 downto 0);
    GT1_DRPCLK_IN                           : in   std_logic;
    GT1_DRPDI_IN                            : in   std_logic_vector(15 downto 0);
    GT1_DRPDO_OUT                           : out  std_logic_vector(15 downto 0);
    GT1_DRPEN_IN                            : in   std_logic;
    GT1_DRPRDY_OUT                          : out  std_logic;
    GT1_DRPWE_IN                            : in   std_logic;
    ------------------------------- Loopback Ports -----------------------------
    GT1_LOOPBACK_IN                         : in   std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    GT1_RXUSERRDY_IN                        : in   std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    GT1_EYESCANDATAERROR_OUT                : out  std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    GT1_RXCDRLOCK_OUT                       : out  std_logic;
    ------------------ Receive Ports - FPGA RX Interface Ports -----------------
    GT1_RXUSRCLK_IN                         : in   std_logic;
    GT1_RXUSRCLK2_IN                        : in   std_logic;
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    GT1_RXDATA_OUT                          : out  std_logic_vector(31 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    GT1_RXPRBSERR_OUT                       : out  std_logic;
    GT1_RXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    GT1_RXPRBSCNTRESET_IN                   : in   std_logic;
    --------------------------- Receive Ports - RX AFE -------------------------
    GT1_GTXRXP_IN                           : in   std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    GT1_GTXRXN_IN                           : in   std_logic;
    ------------------- Receive Ports - RX Buffer Bypass Ports -----------------
    GT1_RXBUFRESET_IN                       : in   std_logic;
    GT1_RXBUFSTATUS_OUT                     : out  std_logic_vector(2 downto 0);
    --------------- Receive Ports - RX Fabric Output Control Ports -------------
    GT1_RXOUTCLK_OUT                        : out  std_logic;
    ---------------------- Receive Ports - RX Gearbox Ports --------------------
    GT1_RXDATAVALID_OUT                     : out  std_logic;
    GT1_RXHEADER_OUT                        : out  std_logic_vector(1 downto 0);
    GT1_RXHEADERVALID_OUT                   : out  std_logic;
    --------------------- Receive Ports - RX Gearbox Ports  --------------------
    GT1_RXGEARBOXSLIP_IN                    : in   std_logic;
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    GT1_GTRXRESET_IN                        : in   std_logic;
    GT1_RXPMARESET_IN                       : in   std_logic;
    ------------------ Receive Ports - RX Margin Analysis ports ----------------
    GT1_RXLPMEN_IN                          : in   std_logic;
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    GT1_RXRESETDONE_OUT                     : out  std_logic;
    ------------------------ TX Configurable Driver Ports ----------------------
    GT1_TXPOSTCURSOR_IN                     : in   std_logic_vector(4 downto 0);
    GT1_TXPRECURSOR_IN                      : in   std_logic_vector(4 downto 0);
    --------------------- TX Initialization and Reset Ports --------------------
    GT1_GTTXRESET_IN                        : in   std_logic;
    GT1_TXUSERRDY_IN                        : in   std_logic;
    ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
    GT1_TXUSRCLK_IN                         : in   std_logic;
    GT1_TXUSRCLK2_IN                        : in   std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    GT1_TXDIFFCTRL_IN                       : in   std_logic_vector(3 downto 0);
    GT1_TXINHIBIT_IN                        : in   std_logic;
    GT1_TXMAINCURSOR_IN                     : in   std_logic_vector(6 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT1_TXDATA_IN                           : in   std_logic_vector(31 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT1_GTXTXN_OUT                          : out  std_logic;
    GT1_GTXTXP_OUT                          : out  std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    GT1_TXOUTCLK_OUT                        : out  std_logic;
    GT1_TXOUTCLKFABRIC_OUT                  : out  std_logic;
    GT1_TXOUTCLKPCS_OUT                     : out  std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    GT1_TXHEADER_IN                         : in   std_logic_vector(1 downto 0);
    GT1_TXSEQUENCE_IN                       : in   std_logic_vector(6 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    GT1_TXRESETDONE_OUT                     : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT1_TXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
   
    --_________________________________________________________________________
        --GT2  (X1Y14)
    --____________________________CHANNEL PORTS________________________________
    ---------------------------- Channel - DRP Ports  --------------------------
    GT2_DRPADDR_IN                          : in   std_logic_vector(8 downto 0);
    GT2_DRPCLK_IN                           : in   std_logic;
    GT2_DRPDI_IN                            : in   std_logic_vector(15 downto 0);
    GT2_DRPDO_OUT                           : out  std_logic_vector(15 downto 0);
    GT2_DRPEN_IN                            : in   std_logic;
    GT2_DRPRDY_OUT                          : out  std_logic;
    GT2_DRPWE_IN                            : in   std_logic;
    ------------------------------- Loopback Ports -----------------------------
    GT2_LOOPBACK_IN                         : in   std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    GT2_RXUSERRDY_IN                        : in   std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    GT2_EYESCANDATAERROR_OUT                : out  std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    GT2_RXCDRLOCK_OUT                       : out  std_logic;
    ------------------ Receive Ports - FPGA RX Interface Ports -----------------
    GT2_RXUSRCLK_IN                         : in   std_logic;
    GT2_RXUSRCLK2_IN                        : in   std_logic;
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    GT2_RXDATA_OUT                          : out  std_logic_vector(31 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    GT2_RXPRBSERR_OUT                       : out  std_logic;
    GT2_RXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    GT2_RXPRBSCNTRESET_IN                   : in   std_logic;
    --------------------------- Receive Ports - RX AFE -------------------------
    GT2_GTXRXP_IN                           : in   std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    GT2_GTXRXN_IN                           : in   std_logic;
    ------------------- Receive Ports - RX Buffer Bypass Ports -----------------
    GT2_RXBUFRESET_IN                       : in   std_logic;
    GT2_RXBUFSTATUS_OUT                     : out  std_logic_vector(2 downto 0);
    --------------- Receive Ports - RX Fabric Output Control Ports -------------
    GT2_RXOUTCLK_OUT                        : out  std_logic;
    ---------------------- Receive Ports - RX Gearbox Ports --------------------
    GT2_RXDATAVALID_OUT                     : out  std_logic;
    GT2_RXHEADER_OUT                        : out  std_logic_vector(1 downto 0);
    GT2_RXHEADERVALID_OUT                   : out  std_logic;
    --------------------- Receive Ports - RX Gearbox Ports  --------------------
    GT2_RXGEARBOXSLIP_IN                    : in   std_logic;
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    GT2_GTRXRESET_IN                        : in   std_logic;
    GT2_RXPMARESET_IN                       : in   std_logic;
    ------------------ Receive Ports - RX Margin Analysis ports ----------------
    GT2_RXLPMEN_IN                          : in   std_logic;
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    GT2_RXRESETDONE_OUT                     : out  std_logic;
    ------------------------ TX Configurable Driver Ports ----------------------
    GT2_TXPOSTCURSOR_IN                     : in   std_logic_vector(4 downto 0);
    GT2_TXPRECURSOR_IN                      : in   std_logic_vector(4 downto 0);
    --------------------- TX Initialization and Reset Ports --------------------
    GT2_GTTXRESET_IN                        : in   std_logic;
    GT2_TXUSERRDY_IN                        : in   std_logic;
    ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
    GT2_TXUSRCLK_IN                         : in   std_logic;
    GT2_TXUSRCLK2_IN                        : in   std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    GT2_TXDIFFCTRL_IN                       : in   std_logic_vector(3 downto 0);
    GT2_TXINHIBIT_IN                        : in   std_logic;
    GT2_TXMAINCURSOR_IN                     : in   std_logic_vector(6 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT2_TXDATA_IN                           : in   std_logic_vector(31 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT2_GTXTXN_OUT                          : out  std_logic;
    GT2_GTXTXP_OUT                          : out  std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    GT2_TXOUTCLK_OUT                        : out  std_logic;
    GT2_TXOUTCLKFABRIC_OUT                  : out  std_logic;
    GT2_TXOUTCLKPCS_OUT                     : out  std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    GT2_TXHEADER_IN                         : in   std_logic_vector(1 downto 0);
    GT2_TXSEQUENCE_IN                       : in   std_logic_vector(6 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    GT2_TXRESETDONE_OUT                     : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT2_TXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
   

    --____________________________COMMON PORTS________________________________
    ---------------------- Common Block  - Ref Clock Ports ---------------------
    GT0_GTREFCLK0_COMMON_IN                 : in   std_logic;
    ------------------------- Common Block - QPLL Ports ------------------------
    GT0_QPLLLOCK_OUT                        : out  std_logic;
    GT0_QPLLLOCKDETCLK_IN                   : in   std_logic;
    GT0_QPLLRESET_IN                        : in   std_logic


);
end component;
COMPONENT RETXdata_chksum
	PORT(
		c : IN std_logic;
		r : IN std_logic;
		ce : IN std_logic;
		d : IN std_logic_vector(31 downto 0);          
		s : OUT std_logic_vector(15 downto 0)
		);
END COMPONENT;
COMPONENT FIFO66x2048
	generic(ALMOSTFULL_OFFSET : bit_vector(15 downto 0) := x"0005";ALMOSTEMPTY_OFFSET : bit_vector(15 downto 0) := x"0008");
	PORT(
		wclk : IN std_logic;
		rclk : IN std_logic;
		fifo_rst : IN std_logic;
		fifo_en : IN std_logic;
		di : IN std_logic_vector(65 downto 0);
		we : IN std_logic;
		re : IN std_logic;          
		do : OUT std_logic_vector(65 downto 0);
		full : OUT std_logic;
		empty : OUT std_logic;
		data_avl : OUT std_logic
		);
END COMPONENT;
COMPONENT RAM32x6D
	PORT(
		wclk : IN std_logic;
		rclk : IN std_logic;
		di : IN std_logic_vector(5 downto 0);
		we : IN std_logic;
		wa : IN std_logic_vector(4 downto 0);
		ra : IN std_logic_vector(4 downto 0);
		ceReg : IN std_logic;          
		do : OUT std_logic_vector(5 downto 0)
		);
END COMPONENT;
signal resetSyncRegs : std_logic_vector(2 downto 0) := (others => '0');
signal ClientClk2XresetSyncRegs : std_logic_vector(2 downto 0) := (others => '0');
signal refclk : std_logic := '0';
signal REFCLK2XPLLRST : std_logic := '0';
signal refclk2x_in : std_logic := '0';
signal ClientClk2x_dcm : std_logic := '0';
signal ClientClk2x : std_logic := '0';
signal ClientClk_dcm : std_logic := '0';
signal ClientClk : std_logic := '0';
signal ClientClk_lock : std_logic := '0';
signal ClientClkToggle : std_logic := '0';
signal ClientClkToggle_q : std_logic := '0';
signal FIFO_rst : std_logic := '0';
signal reset_dl : std_logic := '0';
signal FIFO_en : std_logic := '0';
signal TX_high : std_logic := '0';
signal us_cntr : std_logic_vector(9 downto 0) := (others => '0');
signal ms_cntr : std_logic_vector(10 downto 0) := (others => '0');
signal strobe_us : std_logic := '0';
signal strobe_ms : std_logic := '0';
signal TSclock : std_logic_vector(31 downto 0) := (others => '0');
signal evt_FIFO_full : std_logic_vector(2 downto 0) := (others => '0');
signal evt_FIFO_empty : std_logic_vector(2 downto 0) := (others => '0');
signal evt_FIFO_we : std_logic_vector(2 downto 0) := (others => '0');
signal evt_FIFO_re : std_logic_vector(2 downto 0) := (others => '0');
--signal TCPIP_re : std_logic_vector(2 downto 0) := (others => '0');
signal evt_FIFO_data_avl : std_logic_vector(2 downto 0) := (others => '0');
signal evt_FIFO_di : array3X66 := (others => (others => '0'));
signal evt_FIFO_do : array3X66 := (others => (others => '0'));
--signal EventCntSys : array3X3 := (others => (others => '0'));
--signal EventCnt : array3X3 := (others => (others => '0'));
signal EVENTdata_avl : std_logic_vector(2 downto 0) := (others => '0');
--signal EVENTdata_LEN_we : std_logic_vector(2 downto 0) := (others => '0');
--signal EVENTdata_LEN_re : std_logic_vector(2 downto 0) := (others => '0');
--signal EVENTdata_LEN12 : std_logic_vector(2 downto 0) := (others => '0');
--signal EVENTdata : array3X64 := (others => (others => '0'));
--signal EVENTdata_LEN_di : array3X13 := (others => (others => '0'));
--signal EVENTdata_LEN_wa : array3X5 := (others => (others => '0'));
--signal EVENTdata_LEN_ra : array3X5 := (others => (others => '0'));
--signal EVENTdata_LEN_ra0SyncRegs : array3X4 := (others => (others => '0'));
--signal EVENTdata_LEN : array3X13 := (others => (others => '0'));
signal EVENTdata_addr : array3X13 := (others => (others => '0'));
--signal EVENTdata_space : std_logic_vector(2 downto 0) := (others => '0');
signal re_RETX_ddr_wq : std_logic_vector(2 downto 0) := (others => '0');
signal RETX_ddr_data_we : std_logic_vector(2 downto 0) := (others => '0');
signal RETX_ddr_wrqst : std_logic_vector(2 downto 0) := (others => '0');
signal RETX_ddr_rrqst : std_logic_vector(2 downto 0) := (others => '0');
signal RETX_ddr_out : array3X32 := (others => (others => '0'));
signal RETX_ddr_LEN : array3X5 := (others => (others => '0'));
--signal RETXdata_avl : std_logic_vector(2 downto 0) := (others => '0');
signal RETXdata_we : array3X2 := (others => (others => '0'));
--signal RETXdataRead_done : std_logic_vector(2 downto 0) := (others => '0');
signal DDR2TCPdata : std_logic_vector(32 downto 0) := (others => '0');
signal rst_RETXdata_chksum : std_logic := '0';
--signal ce_RETXdata_chksum : std_logic := '0';
--signal RETXdata_chksum_in : std_logic_vector(16 downto 0) := (others => '0');
signal RETXdata_chksum_out : std_logic_vector(15 downto 0) := (others => '0');
signal RETXdata_checksum : array3x16 := (others => (others => '0'));
signal RETXdataLEN : array3X11 := (others => (others => '0'));
signal RETXdataAddr : array3X26 := (others => (others => '0'));
signal RETXdata_space : std_logic_vector(2 downto 0) := (others => '0');
signal RETXdataRqst : std_logic_vector(2 downto 0) := (others => '0');
signal RETXdataACK : std_logic_vector(2 downto 0) := (others => '0');
signal ReleaseLen : array3X11 := (others => (others => '0'));
signal Release_space : std_logic_vector(2 downto 0) := (others => '0');
signal ReleaseBuffer : std_logic_vector(2 downto 0) := (others => '0');
signal Release_rqst: std_logic_vector(2 downto 0) := (others => '0');
signal rrqst : std_logic := '0';
signal rrqstMask : std_logic_vector(5 downto 0) := (others => '0');
signal rrqstSyncRegs : std_logic_vector(4 downto 0) := (others => '0');
signal TCP_rrqst_i : std_logic := '0';
signal TCP_rrqstSyncRegs : std_logic_vector(3 downto 0) := (others => '0');
signal odd : std_logic := '0';
signal DDR2TCPdata_vld : std_logic := '0';
signal TCP_rFIFO_do_vld : std_logic := '0';
signal ld_RETXdata_chksum : std_logic_vector(2 downto 0) := (others => '0');
signal ld_RETXdata_chksum_r : std_logic_vector(2 downto 0) := (others => '0');
signal ld_RETXdata_chksum_r2 : std_logic_vector(2 downto 0) := (others => '0');
signal TCP_rFIFO_wa0SyncRegs : std_logic_vector(3 downto 0) := (others => '0');
signal TCP_rFIFO_wa1SyncRegs : std_logic_vector(3 downto 0) := (others => '0');
signal TCP_rFIFO_wa2SyncRegs : std_logic_vector(3 downto 0) := (others => '0');
signal TCP_rFIFO_di : std_logic_vector(35 downto 0) := (others => '0');
signal TCP_rFIFO_do : std_logic_vector(35 downto 0) := (others => '0');
signal TCP_rFIFO_wa : std_logic_vector(4 downto 0) := (others => '0');
signal TCP_rFIFO_ra : std_logic_vector(4 downto 0) := (others => '0');
signal RETX_ddr_rp_we : std_logic := '0';
signal RETX_ddr_rp_di : std_logic_vector(17 downto 0) := (others => '0');
signal RETX_ddr_rp_do : std_logic_vector(17 downto 0) := (others => '0');
signal RETX_ddr_rp_a : std_logic_vector(1 downto 0) := (others => '0');
signal TCP_length_i : std_logic_vector(17 downto 0) := (others => '0');
signal TCP_raddr_i : std_logic_vector(25 downto 0) := (others => '0');
signal TCP_rlength : std_logic_vector(10 downto 0) := (others => '0');
signal rdDDRqueue_we : std_logic := '0';
signal rdDDRqueue_re : std_logic := '0';
signal rdDDRqueue_a : std_logic_vector(2 downto 0) := (others => '0');
signal rdDDRqueue_di : std_logic_vector(2 downto 0) := (others => '0');
signal rdDDRqueue_do : std_logic_vector(2 downto 0) := (others => '0');
signal rdDDRqueue_dout : std_logic_vector(2 downto 0) := (others => '0');
signal rdDDRqueue_dout_vld : std_logic := '0';
signal TCP_wFIFO_re : std_logic := '0';
signal TCP_wFIFO_FULL : std_logic := '0';
signal TCP_wFIFO_EMPTY : std_logic := '0';
signal TCP_wFIFO_busy : std_logic := '0';
signal TCP_wFIFO_we : std_logic := '0';
signal TCP_w_sel : std_logic_vector(1 downto 0) := (others => '0');
signal TCP_w_wc : std_logic_vector(3 downto 0) := (others => '0');
signal TCP_wFIFO_DI : std_logic_vector(33 downto 0) := (others => '0');
signal TCP_wFIFO_DO : std_logic_vector(33 downto 0) := (others => '0');
signal TCP_wFIFO_RDCOUNT : std_logic_vector(8 downto 0) := (others => '0');
signal TCP_wFIFO_WRCOUNT : std_logic_vector(8 downto 0) := (others => '0');
signal inh_TX : std_logic_vector(2 downto 0) := (others => '0');
signal inh_TX_q : std_logic_vector(2 downto 0) := (others => '0');
signal reset_TXSyncRegs : std_logic_vector(2 downto 0) := (others => '0');
signal SFP_TXOUTCLK : std_logic_vector(2 downto 0) := (others => '0');
signal txusrclk : std_logic := '0';
signal qplllock : std_logic := '0';
signal qpllreset : std_logic := '0';
signal GTX_TX_READ : std_logic := '0';
signal LINK_down : std_logic_vector(2 downto 0) := (others => '0');
signal EnTCPIP : std_logic_vector(2 downto 0) := (others => '0');
signal SFP_rxoutclk : std_logic_vector(2 downto 0) := (others => '0');
signal SFP_rxusrclk : std_logic_vector(2 downto 0) := (others => '0');
signal SFP_txresetdone : std_logic_vector(2 downto 0) := (others => '0');
signal SFP_gttxreset : std_logic_vector(2 downto 0) := (others => '0');
signal SFP_txuserrdy : std_logic_vector(2 downto 0) := (others => '0');
signal SFP_rxresetdone : std_logic_vector(2 downto 0) := (others => '0');
signal SFP_gtrxreset : std_logic_vector(2 downto 0) := (others => '0');
signal SFP_rxuserrdy : std_logic_vector(2 downto 0) := (others => '0');
signal SFP_drprdy : std_logic_vector(2 downto 0) := (others => '0');
signal SFP_drpen : std_logic_vector(2 downto 0) := (others => '0');
signal SFP_drpwe : std_logic_vector(2 downto 0) := (others => '0');
signal SFP_rxdfeagchold : std_logic_vector(2 downto 0) := (others => '0');
signal SFP_adapt_done : std_logic_vector(2 downto 0) := (others => '0');
signal SFP_rxmonitor : array3X7 := (others => (others => '0'));
signal SFP_drpdo : array3X16 := (others => (others => '0'));
signal SFP_rxmonitorsel : array3X2 := (others => (others => '0'));
signal SFP_drpaddr : array3X9 := (others => (others => '0'));
signal SFP_drpdi : array3X16 := (others => (others => '0'));
signal SFP_RX_FSM_RESET_DONE : std_logic_vector(2 downto 0) := (others => '0');
signal SFP_TX_FSM_RESET_DONE : std_logic_vector(2 downto 0) := (others => '0');
signal SFP_RXDVLD : std_logic_vector(2 downto 0) := (others => '0');
signal SFP_RXHEADERVLD : std_logic_vector(2 downto 0) := (others => '0');
signal SFP_RXGEARBOXSLIP : std_logic_vector(2 downto 0) := (others => '0');
signal SFP_RXGOOD : std_logic_vector(2 downto 0) := (others => '0');
signal SFP_TXD : array3X32 := (others => (others => '0'));
signal SFP_TXD_inv : array3X32 := (others => (others => '0'));
signal SFP_TXHEADER : array3X2 := (others => (others => '0'));
signal SFP_RXD : array3X32 := (others => (others => '0'));
signal SFP_RXD_inv : array3X32 := (others => (others => '0'));
signal SFP_RXHEADER : array3X2 := (others => (others => '0'));
signal SFP_EmacPhyTxD : array3X32 := (others => (others => '0'));
signal SFP_EmacPhyTxC : array3X4 := (others => (others => '0'));
signal SFP_PhyEmacRxD : array3X32 := (others => (others => '0'));
signal SFP_PhyEmacRxC : array3X4 := (others => (others => '0'));
signal EmacPhyTxD : array3X32 := (others => (others => '0'));
signal EmacPhyTxC : array3X4 := (others => (others => '0'));
signal PhyEmacRxD : array3X32 := (others => (others => '0'));
signal PhyEmacRxC : array3X4 := (others => (others => '0'));
signal TCPIP2SFP_sel : array3X2 := (others => (others => '0'));
signal SFP2TCPIP : array3X2 := (others => (others => '0'));
--signal IP_ID : array3X16 := (others => (others => '0'));
signal IPADDR : array3X32 := (others => (others => '0'));
signal SFP_IPADDR : array3X32 := (x"c0a80120",x"c0a80121",x"c0a80122");
signal CWND_max : std_logic_vector(31 downto 0) := (others => '1');
signal MACADDR : array3X48 := (others => (others => '0'));
--signal SFP1_rxoutclk : std_logic := '0';
--signal SFP1_rxusrclk : std_logic := '0';
--signal SFP1_txresetdone : std_logic := '0';
--signal SFP1_gttxreset : std_logic := '0';
--signal SFP1_txuserrdy : std_logic := '0';
--signal SFP1_rxresetdone : std_logic := '0';
--signal SFP1_gtrxreset : std_logic := '0';
--signal SFP1_rxuserrdy : std_logic := '0';
--signal SFP1_drprdy : std_logic := '0';
--signal SFP1_drpen : std_logic := '0';
--signal SFP1_drpwe : std_logic := '0';
--signal SFP1_rxdfeagchold : std_logic := '0';
--signal SFP1_adapt_done : std_logic := '0';
--signal SFP1_rxmonitor : std_logic_vector(6 downto 0) := (others => '0');
--signal SFP1_drpdo : std_logic_vector(15 downto 0) := (others => '0');
--signal SFP1_rxmonitorsel : std_logic_vector(1 downto 0) := (others => '0');
--signal SFP1_drpaddr : std_logic_vector(8 downto 0) := (others => '0');
--signal SFP1_drpdi : std_logic_vector(15 downto 0) := (others => '0');
--signal SFP1_RX_FSM_RESET_DONE : std_logic := '0';
--signal SFP1_TX_FSM_RESET_DONE : std_logic := '0';
--signal SFP1_RXDVLD : std_logic := '0';
--signal SFP1_RXHEADERVLD : std_logic := '0';
--signal SFP1_RXGEARBOXSLIP : std_logic := '0';
--signal SFP1_RXGOOD : std_logic := '0';
--signal SFP1_TXD : std_logic_vector(31 downto 0) := (others => '0');
--signal SFP1_TXD_inv : std_logic_vector(31 downto 0) := (others => '0');
--signal SFP1_TXHEADER : std_logic_vector(1 downto 0) := (others => '0');
--signal SFP1_RXD : std_logic_vector(31 downto 0) := (others => '0');
--signal SFP1_RXD_inv : std_logic_vector(31 downto 0) := (others => '0');
--signal SFP1_RXHEADER : std_logic_vector(1 downto 0) := (others => '0');
--signal SFP2_rxoutclk : std_logic := '0';
--signal SFP2_rxusrclk : std_logic := '0';
--signal SFP2_txresetdone : std_logic := '0';
--signal SFP2_gttxreset : std_logic := '0';
--signal SFP2_txuserrdy : std_logic := '0';
--signal SFP2_rxresetdone : std_logic := '0';
--signal SFP2_gtrxreset : std_logic := '0';
--signal SFP2_rxuserrdy : std_logic := '0';
--signal SFP2_drprdy : std_logic := '0';
--signal SFP2_drpen : std_logic := '0';
--signal SFP2_drpwe : std_logic := '0';
--signal SFP2_rxdfeagchold : std_logic := '0';
--signal SFP2_adapt_done : std_logic := '0';
--signal SFP2_rxmonitor : std_logic_vector(6 downto 0) := (others => '0');
--signal SFP2_drpdo : std_logic_vector(15 downto 0) := (others => '0');
--signal SFP2_rxmonitorsel : std_logic_vector(1 downto 0) := (others => '0');
--signal SFP2_drpaddr : std_logic_vector(8 downto 0) := (others => '0');
--signal SFP2_drpdi : std_logic_vector(15 downto 0) := (others => '0');
--signal SFP2_RX_FSM_RESET_DONE : std_logic := '0';
--signal SFP2_TX_FSM_RESET_DONE : std_logic := '0';
--signal SFP2_RXDVLD : std_logic := '0';
--signal SFP2_RXHEADERVLD : std_logic := '0';
--signal SFP2_RXGEARBOXSLIP : std_logic := '0';
--signal SFP2_RXGOOD : std_logic := '0';
--signal SFP2_TXD : std_logic_vector(31 downto 0) := (others => '0');
--signal SFP2_TXD_inv : std_logic_vector(31 downto 0) := (others => '0');
--signal SFP2_TXHEADER : std_logic_vector(1 downto 0) := (others => '0');
--signal SFP2_RXD : std_logic_vector(31 downto 0) := (others => '0');
--signal SFP2_RXD_inv : std_logic_vector(31 downto 0) := (others => '0');
--signal SFP2_RXHEADER : std_logic_vector(1 downto 0) := (others => '0');
signal GTX_TX_PAUSE : std_logic := '0';
signal TXSEQ_cntr : std_logic_vector(6 downto 0) := (others => '0');
signal SFP_TXSEQUENCE : array3X7 := (others => (others => '0'));
--signal SFP1_TXSEQUENCE : std_logic_vector(6 downto 0) := (others => '0');
--signal SFP2_TXSEQUENCE : std_logic_vector(6 downto 0) := (others => '0');
signal SFP_LOOPBACK_IN : array3X3 := (others => (others => '0'));
signal SFP_RXPRBSERR_OUT : std_logic_vector(2 downto 0) := (others => '0');
signal SFP_RXPRBSSEL_IN : array3X3 := (others => (others => '0'));
signal SFP_TXPRBSSEL_IN : array3X3 := (others => (others => '0'));
signal SFP_EYESCANDATAERROR_OUT : std_logic_vector(2 downto 0) := (others => '0');
--signal SFP1_LOOPBACK_IN : std_logic_vector(2 downto 0) := (others => '0');
--signal SFP1_RXPRBSERR_OUT : std_logic := '0';
--signal SFP1_RXPRBSSEL_IN : std_logic_vector(2 downto 0) := (others => '0');
--signal SFP1_TXPRBSSEL_IN : std_logic_vector(2 downto 0) := (others => '0');
--signal SFP1_EYESCANDATAERROR_OUT : std_logic := '0';
--signal SFP2_LOOPBACK_IN : std_logic_vector(2 downto 0) := (others => '0');
--signal SFP2_RXPRBSERR_OUT : std_logic := '0';
--signal SFP2_RXPRBSSEL_IN : std_logic_vector(2 downto 0) := (others => '0');
--signal SFP2_TXPRBSSEL_IN : std_logic_vector(2 downto 0) := (others => '0');
--signal SFP2_EYESCANDATAERROR_OUT : std_logic := '0';
signal got_eofToggle : std_logic_vector(2 downto 0) := (others => '0');
signal EventBufAddr_we_i : std_logic_vector(2 downto 0) := (others => '0');
signal EventBufAddr_i : array3X17 := (others => (others => '0'));
signal ReadBusy : std_logic_vector(2 downto 0) := (others => '0');
signal UNA_MonBufMatch : std_logic_vector(3 downto 0) := (others => '0');
signal UNA_TCPBufMatch : std_logic_vector(2 downto 0) := (others => '0');
signal UNA_MonBufSyncRegs : std_logic_vector(3 downto 0) := (others => '0');
signal UNA_TCPBufSyncRegs : std_logic_vector(3 downto 0) := (others => '0');
signal inc_ddr_paSyncRegs : std_logic_vector(3 downto 0) := (others => '0');
--signal sysDIV2 : std_logic := '0';
signal evt_FIFO_sel : std_logic := '0';
signal ReleaseMonBuf : std_logic := '0';
signal ReleaseTCPBuf : std_logic := '0';
signal WrtMonBufAllDone_i : std_logic := '0';
signal TCPBufCnt : std_logic_vector(12 downto 0) := (others => '0');
signal MonBufCnt : std_logic_vector(12 downto 0) := (others => '0');
signal WrtMonBuf : std_logic_vector(2 downto 0) := (others => '0');
signal NXT_MonBuf : array3X12 := (others => (others => '0'));
signal LAST_MonBuf : array4X12 := (others => (others => '0'));
signal LAST_MonBufMatch : std_logic_vector(2 downto 0) := (others => '0');
signal NXT_TCPBuf : array3X12 := (others => (others => '0'));
signal UNA_MonBuf : array5X13 := (others => (others => '0'));
signal UNA_TCPBuf : array4X13 := (others => (others => '0'));
signal AddrOffset : array3X10 := (others => (others => '0'));
signal MonAddrOffset : array3X13 := (others => (others => '0'));
signal TCPAddrOffset : array3X13 := (others => (others => '0'));
signal SFPresetSyncRegs : array3X3 := (others => (others => '0'));
signal TCPresetSyncRegs : std_logic_vector(2 downto 0) := (others => '0');
signal got_eofToggle0SyncRegs : std_logic_vector(3 downto 0) := (others => '0');
signal reset_TCPIP : std_logic_vector(2 downto 0) := (others => '0');
signal got_eofToggle1SyncRegs : std_logic_vector(3 downto 0) := (others => '0');
signal got_eofToggle2SyncRegs : std_logic_vector(3 downto 0) := (others => '0');
signal TCPIP_rdata : array3X32 := (others => (others => '0'));
signal AddrBuf_full : std_logic_vector(2 downto 0) := (others => '0');
COMPONENT chipscope
	generic (N : integer := 5);
	PORT(
		clka : IN std_logic;
		clkb : IN std_logic;
		ina : IN std_logic_vector(135 downto 0);
		inb : IN std_logic_vector(135 downto 0)       
		);
END COMPONENT;
COMPONENT chipscope1
	generic (N : integer := 5);
	PORT(
		clk : IN std_logic;
		Din : IN std_logic_vector(303 downto 0)       
		);
END COMPONENT;

type array4x136 is array(0 to 3) of std_logic_vector(135 downto 0);
signal csa : array4x136;
signal csb : array4x136;
signal cs_din : std_logic_vector(303 downto 0) := (others => '0');
begin
--i_chipscope1: chipscope1 generic map(N => 1) PORT MAP(
--		clk => ClientClk2X,
--		Din => cs_din
--	);
cs_din <= csa(0)(135 downto 128) & csa(0)(135 downto 128) & csb(0)(135 downto 128) & csa(0)(135 downto 128) & csb(0)(135 downto 128) & csa(0)(135 downto 128) & csb(0)(127 downto 0) & csa(0)(127 downto 0);
--i_chipscope: chipscope generic map(N => 1) PORT MAP(
--		clka => ClientClk2X,
--		clkb => ClientClk2X,
--		ina => csa(0),
--		inb => csb(0)
--	);
--csa(3)(128) <= RETXdataRqst(0);
csa(3)(129) <= csa(0)(129);
csa(3)(128) <= RETXdataRqst(0);
csa(3)(109 downto 84) <= RETXdataAddr(0);
--csa(3)(84) <= RETXdata_space(0);
csa(3)(83 downto 73) <= RETXdataLEN(0);
csa(3)(72) <= ld_RETXdata_chksum_r2(0);
csa(3)(71 downto 56) <= RETXdata_checksum(0)(15 downto 0);
csa(3)(55 downto 40) <= ReTxdata_chksum_out;
csa(3)(39) <= rst_RETXdata_chksum;
csa(3)(38) <= TCP_rFIFO_do_vld;
csa(3)(37 downto 5) <= TCP_rFIFO_do(32 downto 0);
csa(3)(4 downto 0) <= TCP_rFIFO_ra;
--csb(3)(128) <= TCP_rrqst_i;
--csb(3)(75 downto 71) <= TCP_rFIFO_wa;
--csb(3)(70) <= TCP_lastword;
--csb(3)(69) <= TCP_din_valid;
--csb(3)(68 downto 37) <= TCP_din;
--csb(3)(36) <= TCP_rrqst_i;
--csb(3)(35 downto 26) <= TCP_rlength(9 downto 0);
--csb(3)(25 downto 0) <= TCP_raddr_i;
--csa(3)(132 downto 131) <= buf_rqst;
--csa(3)(130 downto 128) <= evt_data_rdy;
--csa(3)(80 downto 79) <= buf_rqst;
--csa(3)(78 downto 76) <= ReadBusy;
--csa(3)(75 downto 73) <= wport_FIFO_full;
--csa(3)(72 downto 70) <= wport_rdy;
--csa(3)(69 downto 67) <= EventData_we;
--csa(3)(66 downto 64) <= evt_data_rdy;
--csa(3)(63 downto 52) <= NXT_MonBuf(0);
--csa(3)(51 downto 40) <= NXT_TCPBuf(0);
--csa(3)(39 downto 30) <= AddrOffset(0);
--csa(3)(29) <= EventData_in(0)(65);
--csa(3)(28 downto 26) <= EventBufAddr_we_i;
--csa(3)(128) <= Release_rqst(0);
--csa(3)(85 downto 73) <= UNA_TCPBuf(0);
--csa(3)(72 downto 60) <= UNA_MonBuf(0);
--csa(3)(59 downto 50) <= TCPAddrOffset(0);
--csa(3)(49 downto 40) <= MonAddrOffset(0);
--csa(3)(39) <= Release_space(0);
--csa(3)(38) <= ReleaseBuffer(0);
--csa(3)(37) <= Release_rqst(0);
--csa(3)(36 downto 26) <= ReleaseLEN(0);
--csa(3)(25 downto 13) <= TCPBufCnt;
--csa(3)(12 downto 0) <= MonBufCnt;
--csa(3)(131) <= EventBufAddr_we_i(0);
--csa(3)(130) <= Release_rqst(0);
--csa(3)(129) <= TCP_din_valid;
--csa(3)(128) <= RETXdataRqst(0);
--csa(3)(127) <= TCP_rFIFO_do(32);
--csa(3)(126) <= rdDDRqueue_re;
--csa(3)(125) <= ld_RETXdata_chksum(0);
--csa(3)(124) <= rst_RETXdata_chksum;
--csa(3)(123 downto 121) <= rdDDRqueue_a;
--csa(3)(120 downto 118) <= rdDDRqueue_dout;
--csa(3)(117 downto 105) <= UNA_MonBuf(0);
--csa(3)(10) <= ;
--csa(3)(10) <= ;
--csa(3)(10) <= ;
--csa(3)(10) <= ;
--csa(3)(10) <= ;
--csa(3)(99) <= rdDDRqueue_re;
--csa(3)(98) <= TCP_rFIFO_do_vld;
--csa(3)(97) <= rdDDRqueue_dout_vld;
--csa(3)(96) <= odd;
--csa(3)(95) <= DDR2TCPdata_vld;
--csa(3)(94 downto 62) <= DDR2TCPdata;
--csa(3)(61 downto 57) <= TCP_rFIFO_ra;
--csa(3)(56 downto 25) <= TCP_rFIFO_do(31 downto 0);
--csa(3)(24) <= TCP_din_valid;
--csa(3)(23 downto 20) <= TCP_rrqstSyncRegs;
--csa(3)(19) <= rdDDRqueue_we;
--csa(3)(18) <= rrqst;
--csa(3)(17 downto 15) <= rdDDRqueue_di;
--csa(3)(14 downto 12) <= RETX_ddr_rrqst;
--csa(3)(11 downto 6) <= rrqstMask;
--csa(3)(5 downto 3) <= RETXdataAck;
--csa(3)(2 downto 1) <= RETXdata_we(0);
--csa(3)(0) <= RETXdataRqst(0);
--
--csb(3)(129) <= SFP_RXGOOD(0);
--csb(3)(128) <= csa(0)(130);
--csb(3)(36) <= SFP_RXGOOD(0);
--csb(3)(35 downto 32) <= SFP_EmacPhyTxc(0);
--csb(3)(31 downto 0) <= SFP_EmacPhyTxd(0);
--csb(3)(130) <= TCP_rrqst_i;
--csb(3)(129) <= EventBufAddr_we_i(0);
--csb(3)(128) <= TCP_din_valid;
--csb(3)(78 downto 74) <= TCP_rFIFO_wa;
--csb(3)(73 downto 71) <= EventBufAddr_we_i;
--csb(3)(70) <= TCP_lastword;
--csb(3)(69) <= TCP_din_valid;
--csb(3)(68 downto 37) <= TCP_din;
--csb(3)(36) <= TCP_rrqst_i;
--csb(3)(35 downto 24) <= TCP_length_i(11 downto 0);
--csb(3)(23 downto 0) <= TCP_raddr_i;
MonBuf_avl <= not MonBufCnt(12);
TCPBuf_avl <= not TCPBufCnt(12);
EventBufAddr_we <= EventBufAddr_we_i;
EventBufAddr <= EventBufAddr_i;
WrtMonBufAllDone <= WrtMonBufAllDone_i;
TCP_rrqst <= TCP_rrqst_i;
TCP_raddr <= rdDDRqueue_di & TCP_raddr_i;
TCP_length <= TCP_rlength(9 downto 0);
process(sysclk,reset,ClientClk_lock)
begin
	if(reset = '1' or ClientClk_lock = '0')then
		resetSyncRegs <= (others => '1');
	elsif(sysclk'event and sysclk = '1')then
		resetSyncRegs <= resetSyncRegs(1 downto 0) & '0';
	end if;
end process;
process(ClientClk2X,SFP_TX_FSM_RESET_DONE,SFP_RX_FSM_RESET_DONE)
begin
	for i in 0 to 2 loop
		if(SFP_TX_FSM_RESET_DONE(i) = '0' or SFP_RX_FSM_RESET_DONE(i) = '0')then
			SFPresetSyncRegs(i) <= (others => '1');
		elsif(ClientClk2X'event and ClientClk2X = '1')then
			SFPresetSyncRegs(i) <= SFPresetSyncRegs(i)(1 downto 0) & '0';
		end if;
	end loop;
end process;
process(ClientClk2X,reset,ClientClk_lock)
begin
	if(reset = '1' or ClientClk_lock = '0')then
		ClientClk2XresetSyncRegs <= (others => '1');
	elsif(ClientClk2X'event and ClientClk2X = '1')then
		ClientClk2XresetSyncRegs <= ClientClk2XresetSyncRegs(1 downto 0) & '0';
	end if;
end process;
process(ClientClk2X,TCPreset,ClientClk_lock)
begin
	if(TCPreset = '1' or ClientClk_lock = '0')then
		TCPresetSyncRegs <= (others => '1');
	elsif(ClientClk2X'event and ClientClk2X = '1')then
		TCPresetSyncRegs <= TCPresetSyncRegs(1 downto 0) & '0';
	end if;
end process;
process(ClientClk)
begin
	if(ClientClk'event and ClientClk = '1')then
		ClientClkToggle <= not ClientClkToggle;
	end if;
end process;
process(ClientClk2X)
begin
	if(ClientClk2X'event and ClientClk2X = '1')then
		ClientClkToggle_q <= ClientClkToggle;
		TX_high <= ClientClkToggle_q xnor ClientClkToggle;
		if(us_cntr(9) = '1')then
			us_cntr <= "00" & x"c9";
			TSclock <= TSclock + 1;
		else
			us_cntr <= us_cntr + 1;
		end if;
		if(us_cntr(9) = '1')then
			if(ms_cntr(10) = '1')then
				ms_cntr <= x"03" & "000";
			else
				ms_cntr <= ms_cntr + 1;
			end if;
		end if;
		strobe_ms <= us_cntr(9) and ms_cntr(10);
	end if;
end process;
strobe_us <= us_cntr(9);
process(txusrclk)
begin
	if(txusrclk'event and txusrclk = '1')then
		if(TXSEQ_cntr = "1000001")then
			TXSEQ_cntr <= (others => '0');
		else
			TXSEQ_cntr <= TXSEQ_cntr + 1;
		end if;
		if(TXSEQ_cntr(0) = '1')then
			GTX_TX_PAUSE <= and_reduce(TXSEQ_cntr(5 downto 1));
		end if;
		if(inh_TX(0) = '1')then
			SFP_TXSEQUENCE(0) <= (others => '0');
		elsif(TXSEQ_cntr(0) = '1')then
			SFP_TXSEQUENCE(0) <= '0' & TXSEQ_cntr(6 downto 1);
		end if;
		if(inh_TX(1) = '1')then
			SFP_TXSEQUENCE(1) <= (others => '0');
		elsif(TXSEQ_cntr(0) = '1')then
			SFP_TXSEQUENCE(1) <= '0' & TXSEQ_cntr(6 downto 1);
		end if;
		if(inh_TX(2) = '1')then
			SFP_TXSEQUENCE(2) <= (others => '0');
		elsif(TXSEQ_cntr(0) = '1')then
			SFP_TXSEQUENCE(2) <= '0' & TXSEQ_cntr(6 downto 1);
		end if;
	end if;
end process;
process(TXUSRCLK,TCPreset)
begin
	if(TCPreset = '1')then
		reset_TXSyncRegs <= (others => '1');
	elsif(TXUSRCLK'event and TXUSRCLK = '1')then
		reset_TXSyncRegs <= reset_TXSyncRegs(1 downto 0) & '0';
	end if;
end process;
process(TXUSRCLK,SFP_TX_FSM_RESET_DONE(0))
begin
	if(SFP_TX_FSM_RESET_DONE(0) = '0')then
		inh_TX(0) <= '1';
		inh_TX_q(0) <= '1';
	elsif(TXUSRCLK'event and TXUSRCLK = '1')then
		if(TXSEQ_cntr(0) = '1' and TXSEQ_cntr(6) = '1')then
			inh_TX(0) <= '0';
		end if;
		inh_TX_q(0) <= inh_TX(0);
	end if;
end process;
process(TXUSRCLK,SFP_TX_FSM_RESET_DONE(1))
begin
	if(SFP_TX_FSM_RESET_DONE(1) = '0')then
		inh_TX(1) <= '1';
		inh_TX_q(1) <= '1';
	elsif(TXUSRCLK'event and TXUSRCLK = '1')then
		if(TXSEQ_cntr(0) = '1' and TXSEQ_cntr(6) = '1')then
			inh_TX(1) <= '0';
		end if;
		inh_TX_q(1) <= inh_TX(1);
	end if;
end process;
process(TXUSRCLK,SFP_TX_FSM_RESET_DONE(2))
begin
	if(SFP_TX_FSM_RESET_DONE(2) = '0')then
		inh_TX(2) <= '1';
		inh_TX_q(2) <= '1';
	elsif(TXUSRCLK'event and TXUSRCLK = '1')then
		if(TXSEQ_cntr(0) = '1' and TXSEQ_cntr(6) = '1')then
			inh_TX(2) <= '0';
		end if;
		inh_TX_q(2) <= inh_TX(2);
	end if;
end process;
process(sysclk)
begin
	if(sysclk'event and sysclk = '1')then
	  evt_buf_full <= evt_FIFO_full or wport_FIFO_full;
	end if;
end process;
process(sysclk)
begin
	if(sysclk'event and sysclk = '1')then
		if(resetSyncRegs(2) = '1')then
			rrqstSyncRegs <= (others => '0');
		else
			rrqstSyncRegs <= rrqstSyncRegs(3 downto 0) & rrqst;
		end if;
		if(resetSyncRegs(2) = '1' or TCP_rack = '1')then
			TCP_rrqst_i <= '0';
		elsif(rrqstSyncRegs(4 downto 3) = "01")then
			TCP_rrqst_i <= '1';
		end if;
--		sysDIV2 <= not sysDIV2;
	end if;
end process;
process(sysclk)
begin
	if(sysclk'event and sysclk = '1')then
		if(resetSyncRegs(2) = '1')then
			ReadBusy <= (others => '0');
			EventData_re <= (others => '0');
			EventBufAddr_we_i <= (others => '0');
			UNA_MonBufSyncRegs <= (others => '0');
			UNA_TCPBufSyncRegs <= (others => '0');
			ReleaseMonBuf <= '0';
			ReleaseTCPBuf <= '0';
			MonBufCnt <= (others => '0');
			TCPBufCnt <= (others => '0');
			LAST_MonBufMatch <= (others => '1');
			WrtMonBufAllDone_i <= '0';
			NXT_MonBuf <= (others => (others => '0'));
			LAST_MonBuf <= (others => (others => '0'));
			NXT_TCPBuf <= (others => (others => '0'));
		else
			for i in 0 to 2 loop
				if(EVENTdata_in(i)(64) = '1' and EVENTdata_we(i) = '1')then
					ReadBusy(i) <= '0';
				elsif(evt_data_rdy(i) = '1' and wport_rdy(i) = '1' and AddrBuf_full(i) = '0')then
					ReadBusy(i) <= '1';
				end if;
				EventData_re(i) <= evt_data_rdy(i) and wport_rdy(i) and not ReadBusy(i) and not AddrBuf_full(i);
				if(EventData_in(i)(65) = '0' or (EnSFP(3) = '0' and EnSFP(2 downto 0) /= "000"))then
					EventBufAddr_we_i(i) <= evt_data_rdy(i) and wport_rdy(i) and not ReadBusy(i) and not AddrBuf_full(i);
				else
					EventBufAddr_we_i(i) <= '0';
				end if;
			end loop;
			UNA_MonBufSyncRegs <= UNA_MonBufSyncRegs(2 downto 0) & UNA_MonBuf(4)(0);
			UNA_TCPBufSyncRegs <= UNA_TCPBufSyncRegs(2 downto 0) & UNA_TCPBuf(3)(0);
			ReleaseMonBuf <= UNA_MonBufSyncRegs(3) xor UNA_MonBufSyncRegs(2);
			ReleaseTCPBuf <= UNA_TCPBufSyncRegs(3) xor UNA_TCPBufSyncRegs(2);
			if(buf_rqst(0) = '1' and ReleaseMonBuf = '0')then
				MonBufCnt <= MonBufCnt + 1;
			elsif(buf_rqst(0) = '0' and ReleaseMonBuf = '1')then
				MonBufCnt <= MonBufCnt - 1;
			end if;
			if(EnSFP(3) = '1')then
				TCPBufCnt <= (others => '0');
			elsif(buf_rqst(1) = '1' and ReleaseTCPBuf = '0')then
				TCPBufCnt <= TCPBufCnt + 1;
			elsif(buf_rqst(1) = '0' and ReleaseTCPBuf = '1')then
				TCPBufCnt <= TCPBufCnt - 1;
			end if;
			if(LAST_MonBuf(0) = LAST_MonBuf(3))then
				LAST_MonBufMatch(0) <= '1';
			else
				LAST_MonBufMatch(0) <= '0';
			end if;
			if((EnSFP(2 downto 0) = "111" or EnSFP(2 downto 0) = "011" or EnSFP(2 downto 0) = "110" or EnSFP(2 downto 0) = "101") and LAST_MonBuf(1) = LAST_MonBuf(3))then
				LAST_MonBufMatch(1) <= '1';
			else
				LAST_MonBufMatch(1) <= '0';
			end if;
			if(EnSFP(2 downto 0) = "111" and LAST_MonBuf(2) = LAST_MonBuf(3))then
				LAST_MonBufMatch(2) <= '1';
			else
				LAST_MonBufMatch(2) <= '0';
			end if;
			if(LAST_MonBufMatch = "000" and WrtMonBufAllDone_i = '0')then
				LAST_MonBuf(3) <= LAST_MonBuf(3) + 1;
				WrtMonBufAllDone_i <= '1';
			else
				WrtMonBufAllDone_i <= '0';
			end if;
			for i in 0 to 2 loop
				if(EventBufAddr_we_i(i) = '1' and EventData_in(i)(65) = '0')then
--					WrtMonBuf(i) <= '1';
--				elsif(wport_rdy(i) = '1')then
--					WrtMonBuf(i) <= '0';
--				end if;
--				if(WrtMonBuf(i) = '1' and wport_rdy(i) = '1')then
					NXT_MonBuf(i) <= NXT_MonBuf(i) + 1;
				end if;
				if(EventBufAddr_we_i(i) = '1' and EventData_in(i)(65) = '1')then
					NXT_TCPBuf(i) <= NXT_TCPBuf(i) + 1;
				end if;
				if(WrtMonBufDone(i) = '1')then
					LAST_MonBuf(i) <= LAST_MonBuf(i) + 1;
				end if;
			end loop;
		end if;
		for i in 0 to 2 loop
			if(EventData_in(i)(65) = '0')then
				EventBufAddr_i(i) <= '0' & NXT_MonBuf(i) & AddrOffset(i)(9 downto 6);
			else
				EventBufAddr_i(i) <= '1' & NXT_TCPBuf(i) & AddrOffset(i)(9 downto 6);
			end if;
		end loop;
	end if;
end process;
process(ClientClk2X)
begin
	if(ClientClk2X'event and ClientClk2X = '1')then
		if(ClientClk2XresetSyncRegs(2) = '1')then
			inc_ddr_paSyncRegs <= (others => '0');
			UNA_MonBufMatch <= (others => '1');
			UNA_TCPBufMatch <= (others => '1');
			UNA_MonBuf(4) <= (others => '0');
			UNA_MonBuf(3) <= (others => '0');
			UNA_TCPBuf(3) <= (others => '0');
--			for i in 0 to 2 loop
--				MonAddrOffset(i) <= AddrOffset(i) & "000";
--				TCPAddrOffset(i) <= AddrOffset(i) & "000";
--			end loop;
		else
			inc_ddr_paSyncRegs <= inc_ddr_paSyncRegs(2 downto 0) & inc_ddr_pa;
			if(inc_ddr_paSyncRegs(3 downto 2) = "10")then
				UNA_MonBuf(3) <= UNA_MonBuf(3) + 1;
			end if;
			for i in 0 to 2 loop
--				if(enSFP(i) = '1' and UNA_MonBuf(i) = UNA_MonBuf(4))then
				if(enTCPIP(i) = '1' and UNA_MonBuf(i) = UNA_MonBuf(4))then
					UNA_MonBufMatch(i) <= '1';
				else
					UNA_MonBufMatch(i) <= '0';
				end if;
--				if(enSFP(i) = '1' and UNA_TCPBuf(i) = UNA_TCPBuf(3))then
				if(enTCPIP(i) = '1' and UNA_TCPBuf(i) = UNA_TCPBuf(3))then
					UNA_TCPBufMatch(i) <= '1';
				else
					UNA_TCPBufMatch(i) <= '0';
				end if;
			end loop;
			if(UNA_MonBuf(3) = UNA_MonBuf(4))then
				UNA_MonBufMatch(3) <= '1';
			else
				UNA_MonBufMatch(3) <= '0';
			end if;
			if(UNA_MonBufMatch = x"0" and us_cntr(0) = '1')then
				UNA_MonBuf(4) <= UNA_MonBuf(4) + 1;			
			end if;
			if(UNA_TCPBufMatch = "000" and enSFP(2 downto 0) /= "000" and us_cntr(0) = '1')then
				UNA_TCPBuf(3) <= UNA_TCPBuf(3) + 1;			
			end if;
		end if;
		case EnSFP(2 downto 0) is
			when "011" | "101" | "110" => AddrOffset(0)(9 downto 6) <= x"8";
			when "111" => AddrOffset(0)(9 downto 6) <= x"5";
			when others => AddrOffset(0)(9 downto 6) <= x"0";
		end case;
		AddrOffset(1)(9 downto 6) <= x"0";
		AddrOffset(2)(9 downto 6) <= x"a";
--		for i in 0 to 2 loop
--			if(RETXdata_space(i) = '0')then
--				RETXdataAddr(i) <= '0' & UNA_MonBuf(i)(11 downto 0) & MonAddrOffset(i);
--			else
--				RETXdataAddr(i) <= '1' & UNA_TCPBuf(i)(11 downto 0) & TCPAddrOffset(i);
--			end if;
--		end loop;
		if(EnSFP(3) = '0' and or_reduce(EnSFP(2 downto 0)) = '1')then
			EnTCPIP(0) <= '1';
		else
			EnTCPIP(0) <= '0';
		end if;
		if(EnSFP(3) = '0' and (EnSFP(2 downto 0) = "011" or EnSFP(2 downto 0) = "101" or EnSFP(2 downto 0) = "110" or EnSFP(2 downto 0) = "111"))then
			EnTCPIP(1) <= '1';
		else
			EnTCPIP(1) <= '0';
		end if;
		if(EnSFP = x"7")then
			EnTCPIP(2) <= '1';
		else
			EnTCPIP(2) <= '0';
		end if;
	end if;
end process;
i_FIFO_rst : SRL16E
   generic map (
      INIT => X"0000")
   port map (
      Q => FIFO_rst,       -- SRL data output
      A0 => '1',     -- Select[0] input
      A1 => '1',     -- Select[1] input
      A2 => '1',     -- Select[2] input
      A3 => '0',     -- Select[3] input
      CE => '1',     -- Clock enable input
      CLK => sysclk,   -- Clock input
      D => resetSyncRegs(2)        -- SRL data input
   );
i_reset_dl1 : SRL16E
   generic map (
      INIT => X"0000")
   port map (
      Q => reset_dl,       -- SRL data output
      A0 => '1',     -- Select[0] input
      A1 => '1',     -- Select[1] input
      A2 => '1',     -- Select[2] input
      A3 => '0',     -- Select[3] input
      CE => '1',     -- Clock enable input
      CLK => sysclk,   -- Clock input
      D => FIFO_rst        -- SRL data input
   );
process(sysclk)
begin
	if(sysclk'event and sysclk = '1')then
		if(resetSyncRegs(2) = '1')then
			FIFO_en <= '0';
		elsif(reset_dl = '1')then
			FIFO_en <= '1';
		end if;
		for i in 0 to 2 loop
			if(resetSyncRegs(2) = '1' or EventBufAddr_we_i(i) = '1')then
				evt_FIFO_di(i)(65) <= '1';
			elsif(evt_FIFO_we(i) = '1')then
				evt_FIFO_di(i)(65) <= '0';
			end if;
		end loop;
	end if;
end process;
g_evt_FIFO: for i in 0 to 2 generate
	i_evt_FIFO: FIFO66x2048 PORT MAP(
		wclk => sysclk,
		rclk => ClientClk2X,
		fifo_rst => FIFO_rst,
		fifo_en => FIFO_en,
		di => evt_FIFO_di(i),
		we => evt_FIFO_we(i),
		re => evt_FIFO_re(i),
		do => evt_FIFO_do(i),
		full => evt_FIFO_full(i),
		empty => evt_FIFO_empty(i),
		data_avl => open
	);
end generate;
evt_FIFO_di(0)(64 downto 0) <= EVENTdata_in(0)(64 downto 0);
evt_FIFO_di(1)(64 downto 0) <= EVENTdata_in(1)(64 downto 0);
evt_FIFO_di(2)(64 downto 0) <= EVENTdata_in(2)(64 downto 0);
evt_FIFO_we <= "000" when EnSFP(3) = '1' else EVENTdata_we;
EVENTdata_avl <= not evt_FIFO_empty;
g_TCPIP: for i in 0 to 2 generate
	i_TCPIP: TCPIP PORT MAP(
		reset => reset_TCPIP(i),
		rstCntr => rstCntr,
		sysclk => sysclk,
		clk2x => ClientClk2X,
		clk => ClientClk,
		strobe_us => strobe_us,
		strobe_ms => strobe_ms,
		en_LINK => enTCPIP(i),
		LINK_down => LINK_down(i),
--		IP_ID => IP_ID(i),
		MY_PORT => x"1234",
		MY_IP => IPADDR(i),
		MY_ETH => MACADDR(i),
		TSclock => TSclock,
		CWND_max => CWND_max,
		EVENTdata => evt_FIFO_do(i),
		EVENTdata_avl => EVENTdata_avl(i),
		EVENTdata_re => evt_FIFO_re(i),
		DDR2TCPdata => DDR2TCPdata,
		RETXdata_chksum => RETXdata_checksum(i),
		RETXdata_we => RETXdata_we(i),
		RETX_ddr_out => RETX_ddr_out(i),
		re_RETX_ddr_wq_in => re_RETX_ddr_wq(i),
		RETX_ddr_wrqst => RETX_ddr_wrqst(i),
		RETX_ddr_data_we => RETX_ddr_data_we(i),
		RETX_ddr_rrqst => RETX_ddr_rrqst(i),
		RETX_ddr_LEN => RETX_ddr_LEN(i),
		RETXdataACK => RETXdataACK(i),
		RETXdataRqst => RETXdataRqst(i),
		RETXdataAddr => RETXdataAddr(i),
		RETXdataLEN => RETXdataLEN(i),
		EventBufAddr => EventBufAddr_i(i),
		EventBufAddr_we => EventBufAddr_we_i(i),
		AddrBuf_full => AddrBuf_full(i),
		UNA_MonBuf => UNA_MonBuf(i),
		UNA_TCPBuf => UNA_TCPBuf(i),
--		ReleaseLEN => ReleaseLEN(i),
--		Release_space => Release_space(i),
--		ReleaseBuffer => ReleaseBuffer(i),
--		Release_rqst => Release_rqst(i),
		EmacPhyTxC => EmacPhyTxc(i),
		EmacPhyTxD => EmacPhyTxd(i),
		PhyEmacRxC => PhyEmacRxC(i),
		PhyEmacRxD => PhyEmacRxD(i),
		ipb_addr => ipb_addr,
		ipb_rdata => TCPIP_rdata(i),
		csa => csa(i),
		csb => csb(i)
	);
end generate;
process(sysclk)
begin
	if(sysclk'event and sysclk = '1')then
		if(resetSyncRegs(2) = '1')then
			TCP_rFIFO_wa <= (others => '0');
		elsif(TCP_din_valid = '1')then
			case TCP_rFIFO_wa(2 downto 0) is
				when "000" => TCP_rFIFO_wa(2 downto 0) <= "001";
				when "001" => TCP_rFIFO_wa(2 downto 0) <= "011";
				when "011" => TCP_rFIFO_wa(2 downto 0) <= "010";
				when "010" => TCP_rFIFO_wa(2 downto 0) <= "110";
				when "110" => TCP_rFIFO_wa(2 downto 0) <= "111";
				when "111" => TCP_rFIFO_wa(2 downto 0) <= "101";
				when "101" => TCP_rFIFO_wa(2 downto 0) <= "100";
				when others => TCP_rFIFO_wa(2 downto 0) <= "000";
			end case;
		end if;
	end if;
end process;
process(ClientClk2X)
begin
	if(ClientClk2X'event and ClientClk2X = '1')then
		if(ClientClk2XresetSyncRegs(2) = '1')then
			TCP_rFIFO_wa0SyncRegs <= (others => '0');
			TCP_rFIFO_wa1SyncRegs <= (others => '0');
			TCP_rFIFO_wa2SyncRegs <= (others => '0');
			TCP_rFIFO_ra <= (others => '0');
			TCP_rFIFO_do_vld <= '0';
		else
			TCP_rFIFO_wa0SyncRegs <= TCP_rFIFO_wa0SyncRegs(2 downto 0) & TCP_rFIFO_wa(0);
			TCP_rFIFO_wa1SyncRegs <= TCP_rFIFO_wa1SyncRegs(2 downto 0) & TCP_rFIFO_wa(1);
			TCP_rFIFO_wa2SyncRegs <= TCP_rFIFO_wa2SyncRegs(2 downto 0) & TCP_rFIFO_wa(2);
			if(TCP_rFIFO_do_vld = '1' and TCP_rFIFO_do(32) = '1')then
				TCP_rFIFO_do_vld <= '0';
			elsif(TCP_rFIFO_wa2SyncRegs(3) /= TCP_rFIFO_ra(2) or TCP_rFIFO_wa1SyncRegs(3) /= TCP_rFIFO_ra(1) or TCP_rFIFO_wa0SyncRegs(3) /= TCP_rFIFO_ra(0))then
				case TCP_rFIFO_ra(2 downto 0) is
					when "000" => TCP_rFIFO_ra(2 downto 0) <= "001";
					when "001" => TCP_rFIFO_ra(2 downto 0) <= "011";
					when "011" => TCP_rFIFO_ra(2 downto 0) <= "010";
					when "010" => TCP_rFIFO_ra(2 downto 0) <= "110";
					when "110" => TCP_rFIFO_ra(2 downto 0) <= "111";
					when "111" => TCP_rFIFO_ra(2 downto 0) <= "101";
					when "101" => TCP_rFIFO_ra(2 downto 0) <= "100";
					when others => TCP_rFIFO_ra(2 downto 0) <= "000";
				end case;
				TCP_rFIFO_do_vld <= '1';
			else
				TCP_rFIFO_do_vld <= '0';
			end if;
		end if;
	end if;
end process;
g_TCP_rFIFO : for i in 0 to 5 generate
	i_TCP_rFIFO: RAM32x6D PORT MAP(
		wclk => sysclk,
		rclk => ClientClk2X,
		di => TCP_rFIFO_di(i*6+5 downto i*6),
		we => TCP_din_valid,
		wa => TCP_rFIFO_wa,
		ra => TCP_rFIFO_ra,
		ceReg => '1',
		do => TCP_rFIFO_do(i*6+5 downto i*6)
	);
end generate;
TCP_rFIFO_di(32) <= TCP_lastword;
TCP_rFIFO_di(31 downto 0) <= TCP_din;
i_RETXdata_chksum: RETXdata_chksum PORT MAP(
		c => ClientClk2X,
		r => rst_RETXdata_chksum,
		ce => TCP_rFIFO_do_vld,
		d => TCP_rFIFO_do(31 downto 0),
		s => RETXdata_chksum_out
	);
g_rdDDRqueue : for i in 0 to 2 generate
	i_rdDDRqueue : SRL16E
   port map (
      Q => rdDDRqueue_do(i),       -- SRL data output
      A0 => rdDDRqueue_a(0),     -- Select[0] input
      A1 => rdDDRqueue_a(1),     -- Select[1] input
      A2 => rdDDRqueue_a(2),     -- Select[2] input
      A3 => '0',     -- Select[3] input
      CE => rdDDRqueue_we,     -- Clock enable input
      CLK => ClientClk2X,   -- Clock input
      D => rdDDRqueue_di(i)        -- SRL data input
   );
end generate;
rdDDRqueue_re <= TCP_rFIFO_do(32) and TCP_rFIFO_do_vld;
process(ClientClk2X)
begin
	if(ClientClk2X'event and ClientClk2X = '1')then
		if(ClientClk2XresetSyncRegs(2) = '1')then
			rdDDRqueue_a <= (others => '1');
		elsif(rdDDRqueue_we = '1' and rdDDRqueue_re = '0' and (rdDDRqueue_dout_vld = '1' or and_reduce(rdDDRqueue_a) = '1'))then
			rdDDRqueue_a <= rdDDRqueue_a + 1;
		elsif((rdDDRqueue_re = '1' or rdDDRqueue_dout_vld = '0') and and_reduce(rdDDRqueue_a) = '0' and rdDDRqueue_we = '0')then
			rdDDRqueue_a <= rdDDRqueue_a - 1;
		end if;
		if(ClientClk2XresetSyncRegs(2) = '1')then
			rdDDRqueue_dout_vld <= '0';
		elsif(and_reduce(rdDDRqueue_a) = '0')then
			rdDDRqueue_dout_vld <= '1';
		elsif(rdDDRqueue_re = '1')then
			rdDDRqueue_dout_vld <= '0';
		end if;
		if(rdDDRqueue_dout_vld = '0' or rdDDRqueue_re = '1')then
			rdDDRqueue_dout <= rdDDRqueue_do;
		end if;
		if(rdDDRqueue_re = '1' and rdDDRqueue_dout = "100")then
			ld_RETXdata_chksum(0) <= '1';
		else
			ld_RETXdata_chksum(0) <= '0';
		end if;
		if(rdDDRqueue_re = '1' and rdDDRqueue_dout = "101")then
			ld_RETXdata_chksum(1) <= '1';
		else
			ld_RETXdata_chksum(1) <= '0';
		end if;
		if(rdDDRqueue_re = '1' and rdDDRqueue_dout = "110")then
			ld_RETXdata_chksum(2) <= '1';
		else
			ld_RETXdata_chksum(2) <= '0';
		end if;
		ld_RETXdata_chksum_r <= ld_RETXdata_chksum;
		ld_RETXdata_chksum_r2 <= ld_RETXdata_chksum_r;
		if(ld_RETXdata_chksum_r2(0) = '1')then
			RETXdata_checksum(0) <= RETXdata_chksum_out;
		end if;
		if(ld_RETXdata_chksum_r2(1) = '1')then
			RETXdata_checksum(1) <= RETXdata_chksum_out;
		end if;
		if(ld_RETXdata_chksum_r2(2) = '1')then
			RETXdata_checksum(2) <= RETXdata_chksum_out;
		end if;
		if(ClientClk2XresetSyncRegs(2) = '1')then
			rst_RETXdata_chksum <= '1';
		else
			rst_RETXdata_chksum <= TCP_rFIFO_do(32) and TCP_rFIFO_do_vld;
		end if;
		DDR2TCPdata_vld <= TCP_rFIFO_do_vld;
		DDR2TCPdata <= TCP_rFIFO_do(32 downto 0);
		if(TCP_rFIFO_do_vld = '1' and rdDDRqueue_dout = "000")then
			RETX_ddr_data_we(0) <= '1';
		else
			RETX_ddr_data_we(0) <= '0';
		end if;
		if(TCP_rFIFO_do_vld = '1' and rdDDRqueue_dout = "001")then
			RETX_ddr_data_we(1) <= '1';
		else
			RETX_ddr_data_we(1) <= '0';
		end if;
		if(TCP_rFIFO_do_vld = '1' and rdDDRqueue_dout = "010")then
			RETX_ddr_data_we(2) <= '1';
		else
			RETX_ddr_data_we(2) <= '0';
		end if;
		if(ClientClk2XresetSyncRegs(2) = '1')then
			odd <= '0';
		elsif(TCP_rFIFO_do_vld = '1')then
			odd <= not odd and not DDR2TCPdata(32);
		end if;
		if(TCP_rFIFO_do_vld = '1' and rdDDRqueue_dout = "100")then
			RETXdata_we(0) <= odd & not odd;
		else
			RETXdata_we(0) <= "00";
		end if;
		if(TCP_rFIFO_do_vld = '1' and rdDDRqueue_dout = "101")then
			RETXdata_we(1) <= odd & not odd;
		else
			RETXdata_we(1) <= "00";
		end if;
		if(TCP_rFIFO_do_vld = '1' and rdDDRqueue_dout = "110")then
			RETXdata_we(2) <= odd & not odd;
		else
			RETXdata_we(2) <= "00";
		end if;
		if(ClientClk2XresetSyncRegs(2) = '1')then
			TCP_rrqstSyncRegs <= (others => '0');
			RETX_ddr_rp_di <= (others => '0');
			RETX_ddr_rp_a <= RETX_ddr_rp_a + 1;
			RETX_ddr_rp_we <= '1';
			rrqst <= '0';
			rdDDRqueue_we <= '0';
			rrqstMask <= (others => '1');
		else
			TCP_rrqstSyncRegs <= TCP_rrqstSyncRegs(2 downto 0) & TCP_rrqst_i;
			RETX_ddr_rp_di <= RETX_ddr_rp_do + TCP_length_i;
			RETX_ddr_rp_we <= TCP_rrqstSyncRegs(3) and not TCP_rrqstSyncRegs(2) and not rdDDRqueue_di(2);
			if(TCP_rrqstSyncRegs(3 downto 2) = "10")then
				rrqst <= '0';
			elsif(or_reduce(rrqstMask(2 downto 0) and RETX_ddr_rrqst) = '1' or or_reduce(rrqstMask(5 downto 3) and RETXdataRqst) = '1')then
				rrqst <= '1';
			end if;
			if(TCP_rrqstSyncRegs(3 downto 2) = "01")then
				rdDDRqueue_we <= '1';
			else
				rdDDRqueue_we <= '0';
			end if;
			if(rdDDRqueue_re = '1')then
				if(rdDDRqueue_dout(2) = '1')then
					rrqstMask(3+conv_integer(rdDDRqueue_dout(1 downto 0))) <= '1';
				else
					rrqstMask(conv_integer(rdDDRqueue_dout(1 downto 0))) <= '1';
				end if;
			elsif(rrqst = '1')then
				if(rdDDRqueue_di(2) = '1')then
					rrqstMask(3+conv_integer(rdDDRqueue_di(1 downto 0))) <= '0';
				else
					rrqstMask(conv_integer(rdDDRqueue_di(1 downto 0))) <= '0';
				end if;
			end if;
		end if;
		if(rrqst = '0')then
			RETXdataAck <= (others => '0');
		else
			case rdDDRqueue_di(1 downto 0) is
				when "00" => RETXdataAck <= "001";
				when "01" => RETXdataAck <= "010";
				when "10" => RETXdataAck <= "100";
				when others => RETXdataAck <= "000";
			end case;
		end if;
		if(rrqst = '0')then
			if(or_reduce(rrqstMask(5 downto 3) and RETXdataRqst) = '1')then
				rdDDRqueue_di(2) <= '1';
				if(rrqstMask(3) = '1' and RETXdataRqst(0) = '1')then
					rdDDRqueue_di(1 downto 0) <= "00";
				elsif(rrqstMask(4) = '1' and RETXdataRqst(1) = '1')then
					rdDDRqueue_di(1 downto 0) <= "01";
				else
					rdDDRqueue_di(1 downto 0) <= "10";
				end if;
				RETX_ddr_rp_a <= "11";
			else
				rdDDRqueue_di(2) <= '0';
				if(rrqstMask(0) = '1' and RETX_ddr_rrqst(0) = '1')then
					rdDDRqueue_di(1 downto 0) <= "00";
					RETX_ddr_rp_a <= "00";
				elsif(rrqstMask(1) = '1' and RETX_ddr_rrqst(1) = '1')then
					rdDDRqueue_di(1 downto 0) <= "01";
					RETX_ddr_rp_a <= "01";
				else
					rdDDRqueue_di(1 downto 0) <= "10";
					RETX_ddr_rp_a <= "10";
				end if;
			end if;
		end if;
		case rdDDRqueue_di is
			when "100" => TCP_raddr_i <= RETXdataAddr(0);
			when "101" => TCP_raddr_i <= RETXdataAddr(1);
			when "110" => TCP_raddr_i <= RETXdataAddr(2);
			when others => TCP_raddr_i <= rdDDRqueue_di(1 downto 0) & RETX_ddr_rp_do(17 downto 7) & x"f" & RETX_ddr_rp_do(6 downto 0) & "00";
		end case;
		TCP_rlength <= TCP_length_i(11 downto 1) - 1;
		case rdDDRqueue_di is
			when "000" => TCP_length_i(11 downto 0) <= "000" & RETX_ddr_LEN(0) & x"0";
			when "001" => TCP_length_i(11 downto 0) <= "000" & RETX_ddr_LEN(1) & x"0";
			when "010" => TCP_length_i(11 downto 0) <= "000" & RETX_ddr_LEN(2) & x"0";
			when "100" => TCP_length_i(11 downto 0) <= RETXdataLEN(0) & '0';
			when "101" => TCP_length_i(11 downto 0) <= RETXdataLEN(1) & '0';
			when "110" => TCP_length_i(11 downto 0) <= RETXdataLEN(2) & '0';
			when others => TCP_length_i(11 downto 0) <= x"000";
		end case;
	end if;
end process;
g_RETX_ddr_rp : for i in 0 to 8 generate
   i_RETX_ddr_rp : RAM32X2S
   port map (
      O0 => RETX_ddr_rp_do(2*i),     -- RAM data[0] output
      O1 => RETX_ddr_rp_do(2*i+1),     -- RAM data[1] output
      A0 => RETX_ddr_rp_a(0),     -- RAM address[0] input
      A1 => RETX_ddr_rp_a(1),     -- RAM address[1] input
      A2 => '0',     -- RAM address[2] input
      A3 => '0',     -- RAM address[3] input
      A4 => '0',     -- RAM address[4] input
      D0 => RETX_ddr_rp_di(2*i),     -- RAM data[0] input
      D1 => RETX_ddr_rp_di(2*i+1),     -- RAM data[1] input
      WCLK => ClientClk2X, -- Write clock input
      WE => RETX_ddr_rp_we      -- Write enable input
   );
end generate;
i_TCP_wFIFO : FIFO_DUALCLOCK_MACRO
   generic map (
      DEVICE => "7SERIES",            -- Target Device: "VIRTEX5", "VIRTEX6", "7SERIES" 
      ALMOST_FULL_OFFSET => X"0020",  -- Sets almost full threshold
      ALMOST_EMPTY_OFFSET => X"0080", -- Sets the almost empty threshold
      DATA_WIDTH => 34,   -- Valid values are 1-72 (37-72 only valid when FIFO_SIZE="36Kb")
      FIFO_SIZE => "18Kb",            -- Target BRAM, "18Kb" or "36Kb" 
      FIRST_WORD_FALL_THROUGH => TRUE) -- Sets the FIFO FWFT to TRUE or FALSE
   port map (
      ALMOSTEMPTY => open,   -- 1-bit output almost empty
      ALMOSTFULL => TCP_wFIFO_FULL,     -- 1-bit output almost full
      DO => TCP_wFIFO_DO,                     -- Output data, width defined by DATA_WIDTH parameter
      EMPTY => TCP_wFIFO_EMPTY,               -- 1-bit output empty
      FULL => open,                 -- 1-bit output full
      RDCOUNT => TCP_wFIFO_RDCOUNT,           -- Output read count, width determined by FIFO depth
      RDERR => open,               -- 1-bit output read error
      WRCOUNT => TCP_wFIFO_WRCOUNT,           -- Output write count, width determined by FIFO depth
      WRERR => open,               -- 1-bit output write error
      DI => TCP_wFIFO_DI,                     -- Input data, width defined by DATA_WIDTH parameter
      RDCLK => sysclk,               -- 1-bit input read clock
      RDEN => TCP_wFIFO_re,                 -- 1-bit input read enable
      RST => FIFO_rst,                   -- 1-bit input reset
      WRCLK => ClientClk2X,               -- 1-bit input write clock
      WREN => TCP_wFIFO_we                  -- 1-bit input write enable
   );
TCP_wFIFO_re <= FIFO_en and TCP_re;
TCP_wrqst <= FIFO_en and not TCP_wFIFO_EMPTY;
TCP_channel <= TCP_wFIFO_DO(33 downto 32);
TCP_dout <= TCP_wFIFO_DO(31 downto 0);
process(ClientClk2X, TCP_w_sel, RETX_ddr_wrqst)
variable s : std_logic_vector(4 downto 0);
begin
	s := TCP_w_sel & RETX_ddr_wrqst;
	if(ClientClk2X'event and ClientClk2X = '1')then
		if(FIFO_en = '0' or ClientClk2XresetSyncRegs(2) = '1')then
			TCP_w_sel <= "00";
			TCP_wFIFO_busy <= '0';
		elsif(TCP_wFIFO_FULL = '0' and TCP_wFIFO_busy = '0')then
			case s is
				when "00001" | "01001" | "01011" | "10001" | "10011" | "10101" | "10111" =>
					TCP_w_sel <= "00";
					TCP_wFIFO_busy <= '1';
				when "00010" | "00011" | "00110" | "00111" | "01010" | "10010" | "10110" =>
					TCP_w_sel <= "01";
					TCP_wFIFO_busy <= '1';
				when "00100" | "00101" | "01100" | "01101" | "01110" | "01111" | "10100" =>
					TCP_w_sel <= "10";
					TCP_wFIFO_busy <= '1';
				when others => null;	
			end case;
		elsif(TCP_w_wc = x"f")then
			TCP_wFIFO_busy <= '0';
		end if;
		if(ClientClk2XresetSyncRegs(2) = '1')then
			TCP_w_wc <= x"0";
		elsif(TCP_wFIFO_busy = '1')then
			TCP_w_wc <= TCP_w_wc + 1;
		end if;
		if(FIFO_en = '0' or ClientClk2XresetSyncRegs(2) = '1')then
			re_RETX_ddr_wq <= "000";
			TCP_wFIFO_we <= '0';
		else
			case TCP_w_sel is
				when "00" => re_RETX_ddr_wq(0) <= TCP_wFIFO_busy;
				when "01" => re_RETX_ddr_wq(1) <= TCP_wFIFO_busy;
				when others => re_RETX_ddr_wq(2) <= TCP_wFIFO_busy;
			end case;
			TCP_wFIFO_we <= TCP_wFIFO_busy;
		end if;
		case TCP_w_sel is
			when "00" => TCP_wFIFO_DI <= "00" & RETX_ddr_out(0);
			when "01" => TCP_wFIFO_DI <= "01" & RETX_ddr_out(1);
			when others => TCP_wFIFO_DI <= "10" & RETX_ddr_out(2);
		end case;
	end if;
end process;
process(ClientClk2X)
begin
	if(ClientClk2X'event and ClientClk2X = '1')then
		case EnSFP(2 downto 0) is
			when "010" | "011" | "101" | "111" => TCPIP2SFP_sel(0) <= "01";
			when "100" | "110" => TCPIP2SFP_sel(0) <= "10";
			when others => TCPIP2SFP_sel(0) <= "00";
		end case;
		case EnSFP(2 downto 0) is
			when "010" | "011" | "111" => TCPIP2SFP_sel(1) <= "00";
			when "101" => TCPIP2SFP_sel(1) <= "10";
			when others => TCPIP2SFP_sel(1) <= "01";
		end case;
		case EnSFP(2 downto 0) is
			when "100" | "101" | "110" => TCPIP2SFP_sel(2) <= "00";
			when others => TCPIP2SFP_sel(2) <= "10";
		end case;
		for i in 0 to 1 loop
			SFP_EmacPhyTxc(i) <= EmacPhyTxc(conv_integer(TCPIP2SFP_sel(i)));
			SFP_EmacPhyTxD(i) <= EmacPhyTxD(conv_integer(TCPIP2SFP_sel(i)));
			SFP_down(i) <= LINK_down(conv_integer(TCPIP2SFP_sel(i)));
		end loop;
		if(TCPIP2SFP_sel(2)(1) = '0')then
			SFP_EmacPhyTxc(2) <= EmacPhyTxc(0);
			SFP_EmacPhyTxD(2) <= EmacPhyTxD(0);
			SFP_down(2) <= LINK_down(0);
		else
			SFP_EmacPhyTxc(2) <= EmacPhyTxc(2);
			SFP_EmacPhyTxD(2) <= EmacPhyTxD(2);
			SFP_down(2) <= LINK_down(2);
		end if;
		case EnSFP(2 downto 0) is
			when "010" | "011" | "111" => SFP2TCPIP(0) <= "01";
			when "100" | "101" | "110" => SFP2TCPIP(0) <= "10";
			when others => SFP2TCPIP(0) <= "00";
		end case;
		case EnSFP(2 downto 0) is
			when "010" | "011" | "101" | "111" => SFP2TCPIP(1) <= "00";
			when others => SFP2TCPIP(1) <= "01";
		end case;
		case EnSFP(2 downto 0) is
			when "100" | "110" => SFP2TCPIP(2) <= "00";
			when "101" => SFP2TCPIP(2) <= "01";
			when others => SFP2TCPIP(2) <= "10";
		end case;
		PhyEmacRxc(0) <= SFP_PhyEmacRxc(conv_integer(SFP2TCPIP(0)));
		PhyEmacRxD(0) <= SFP_PhyEmacRxD(conv_integer(SFP2TCPIP(0)));
		if(SFP2TCPIP(1)(0) = '0')then
			PhyEmacRxc(1) <= SFP_PhyEmacRxc(0);
			PhyEmacRxD(1) <= SFP_PhyEmacRxD(0);
		else
			PhyEmacRxc(1) <= SFP_PhyEmacRxc(1);
			PhyEmacRxD(1) <= SFP_PhyEmacRxD(1);
		end if;
		PhyEmacRxc(2) <= SFP_PhyEmacRxc(conv_integer(SFP2TCPIP(2)));
		PhyEmacRxD(2) <= SFP_PhyEmacRxD(conv_integer(SFP2TCPIP(2)));
--		IP_ID(0) <= x"000" & "00" & SFP2TCPIP(0);
--		IP_ID(1) <= x"000" & "000" & SFP2TCPIP(1)(0);
--		IP_ID(2) <= x"000" & "00" & SFP2TCPIP(2);
		IPADDR(0) <= SFP_IPADDR(conv_integer(SFP2TCPIP(0)));
		IPADDR(1) <= SFP_IPADDR(conv_integer(SFP2TCPIP(1)));
		IPADDR(2) <= SFP_IPADDR(conv_integer(SFP2TCPIP(2)));
		MACADDR(0) <= x"00ac1234568" & "10" & SFP2TCPIP(0);
		MACADDR(1) <= x"00ac1234568" & "100" & SFP2TCPIP(1)(0);
		MACADDR(2) <= x"00ac1234568" & "10" & SFP2TCPIP(2);
		reset_TCPIP(0) <= SFPresetSyncRegs(conv_integer(SFP2TCPIP(0)))(2);
		if(SFP2TCPIP(1)(0) = '0')then
			reset_TCPIP(1) <= SFPresetSyncRegs(conv_integer(SFP2TCPIP(0)))(2);
		else
			reset_TCPIP(1) <= SFPresetSyncRegs(conv_integer(SFP2TCPIP(1)))(2);
		end if;
		reset_TCPIP(2) <= SFPresetSyncRegs(conv_integer(SFP2TCPIP(2)))(2);
	end if;
end process;
g_XGbEPCS : for i in 0 to 2 generate
	i_XGbEPCS: XGbEPCS32 PORT MAP (
		reset => TCPresetSyncRegs(2),
		clk2x => ClientClk2X,
		clk => ClientClk,
		TXUSRCLK => txusrclk,
		TX_high => TX_high,
		RXUSRCLK => SFP_RXUSRCLK(i),
		RXRESETDONE => SFP_RXRESETDONE(i),
		inh_TX => inh_TX(i),
		RESET_TXSync => reset_TXSyncRegs(2),
		GTX_RXGEARBOXSLIP_OUT => SFP_RXGEARBOXSLIP(i),
		GTX_TXD => SFP_TXD(i),
		GTX_TXHEADER => SFP_TXHEADER(i),
		GTX_TX_PAUSE => GTX_TX_PAUSE,
		GTX_RXD => SFP_RXD(i),
		GTX_RXDVLD => SFP_RXDVLD(i),
		GTX_RXHEADER => SFP_RXHEADER(i),
		GTX_RXHEADERVLD => SFP_RXHEADERVLD(i),
		GTX_RXGOOD => SFP_RXGOOD(i),
		EmacPhyTxC => SFP_EmacPhyTxc(i),
		EmacPhyTxD => SFP_EmacPhyTxd(i),
		PhyEmacRxC => SFP_PhyEmacRxC(i),
		PhyEmacRxD => SFP_PhyEmacRxD(i)
	);
end generate;
i_SFP3_init : SFP3_init
    port map
    (
        SYSCLK_IN                       =>      DRPclk,
        SOFT_RESET_IN                   =>      '0',
        DONT_RESET_ON_DATA_ERROR_IN     =>      '0',
        GT0_TX_FSM_RESET_DONE_OUT       =>      SFP_TX_FSM_RESET_DONE(0),
        GT0_RX_FSM_RESET_DONE_OUT       =>      SFP_RX_FSM_RESET_DONE(0),
        GT0_DATA_VALID_IN               =>      SFP_RXGOOD(0),
        GT1_TX_FSM_RESET_DONE_OUT       =>      SFP_TX_FSM_RESET_DONE(1),
        GT1_RX_FSM_RESET_DONE_OUT       =>      SFP_RX_FSM_RESET_DONE(1),
        GT1_DATA_VALID_IN               =>      SFP_RXGOOD(1),
        GT2_TX_FSM_RESET_DONE_OUT       =>      SFP_TX_FSM_RESET_DONE(2),
        GT2_RX_FSM_RESET_DONE_OUT       =>      SFP_RX_FSM_RESET_DONE(2),
        GT2_DATA_VALID_IN               =>      SFP_RXGOOD(2),

  
 
 
 
        --_____________________________________________________________________
        --_____________________________________________________________________
        --GT0  (X1Y12)

        ---------------------------- Channel - DRP Ports  --------------------------
        GT0_DRPADDR_IN                  => SFP_drpaddr(0),
        GT0_DRPCLK_IN                   => DRPclk,
        GT0_DRPDI_IN                    => SFP_drpdi(0),
        GT0_DRPDO_OUT                   => SFP_drpdo(0),
        GT0_DRPEN_IN                    => SFP_drpen(0),
        GT0_DRPRDY_OUT                  => SFP_drprdy(0),
        GT0_DRPWE_IN                    => SFP_drpwe(0),
        ------------------------------- Loopback Ports -----------------------------
        GT0_LOOPBACK_IN                 => SFP_LOOPBACK_IN(0),
        --------------------- RX Initialization and Reset Ports --------------------
        GT0_RXUSERRDY_IN                => SFP_rxuserrdy(0),
        -------------------------- RX Margin Analysis Ports ------------------------
        GT0_EYESCANDATAERROR_OUT        => SFP_EYESCANDATAERROR_OUT(0),
        ------------------------- Receive Ports - CDR Ports ------------------------
        GT0_RXCDRLOCK_OUT               =>      open,
        ------------------ Receive Ports - FPGA RX Interface Ports -----------------
        GT0_RXUSRCLK_IN                 => SFP_RXUSRCLK(0),
        GT0_RXUSRCLK2_IN                => SFP_RXUSRCLK(0),
        ------------------ Receive Ports - FPGA RX interface Ports -----------------
        GT0_RXDATA_OUT                  => SFP_RXD_inv(0),
        ------------------- Receive Ports - Pattern Checker Ports ------------------
        GT0_RXPRBSERR_OUT               => SFP_RXPRBSERR_OUT(0),
        GT0_RXPRBSSEL_IN                => SFP_RXPRBSSEL_IN(0),
        ------------------- Receive Ports - Pattern Checker ports ------------------
        GT0_RXPRBSCNTRESET_IN           =>      '0',
        --------------------------- Receive Ports - RX AFE -------------------------
        GT0_GTXRXP_IN                   => SFP0_RXP,
        ------------------------ Receive Ports - RX AFE Ports ----------------------
        GT0_GTXRXN_IN                   => SFP0_RXN,
        ------------------- Receive Ports - RX Buffer Bypass Ports -----------------
        GT0_RXBUFRESET_IN               => '0',
        GT0_RXBUFSTATUS_OUT             => open,
        --------------- Receive Ports - RX Fabric Output Control Ports -------------
        GT0_RXOUTCLK_OUT                => SFP_rxoutclk(0),
        ---------------------- Receive Ports - RX Gearbox Ports --------------------
        GT0_RXDATAVALID_OUT             => SFP_RXDVLD(0),
        GT0_RXHEADER_OUT                => SFP_RXHEADER(0),
        GT0_RXHEADERVALID_OUT           => SFP_RXHEADERVLD(0),
        --------------------- Receive Ports - RX Gearbox Ports  --------------------
        GT0_RXGEARBOXSLIP_IN            => SFP_RXGEARBOXSLIP(0),
        ------------- Receive Ports - RX Initialization and Reset Ports ------------
        GT0_GTRXRESET_IN                => SFP_gtrxreset(0),
        GT0_RXPMARESET_IN               => '0',
        ------------------ Receive Ports - RX Margin Analysis ports ----------------
        GT0_RXLPMEN_IN                  => '0',
        -------------- Receive Ports -RX Initialization and Reset Ports ------------
        GT0_RXRESETDONE_OUT             => SFP_rxresetdone(0),
        ------------------------ TX Configurable Driver Ports ----------------------
        GT0_TXPOSTCURSOR_IN             => (others => '0'),
        GT0_TXPRECURSOR_IN              => (others => '0'),
        --------------------- TX Initialization and Reset Ports --------------------
        GT0_GTTXRESET_IN                => SFP_gttxreset(0),
        GT0_TXUSERRDY_IN                => SFP_txuserrdy(0),
        ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
        GT0_TXUSRCLK_IN                 => txusrclk,
        GT0_TXUSRCLK2_IN                => txusrclk,
        --------------- Transmit Ports - TX Configurable Driver Ports --------------
        GT0_TXDIFFCTRL_IN               => "1110",
        GT0_TXINHIBIT_IN                => '0',
        GT0_TXMAINCURSOR_IN             => (others => '0'),
        ------------------ Transmit Ports - TX Data Path interface -----------------
        GT0_TXDATA_IN                   => SFP_TXD_inv(0),
        ---------------- Transmit Ports - TX Driver and OOB signaling --------------
        GT0_GTXTXN_OUT                  => SFP0_TXN,
        GT0_GTXTXP_OUT                  => SFP0_TXP,
        ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
        GT0_TXOUTCLK_OUT                => SFP_TXOUTCLK(0),
        GT0_TXOUTCLKFABRIC_OUT          => open,
        GT0_TXOUTCLKPCS_OUT             => open,
        --------------------- Transmit Ports - TX Gearbox Ports --------------------
        GT0_TXHEADER_IN                 => SFP_TXHEADER(0),
        GT0_TXSEQUENCE_IN               => SFP_TXSEQUENCE(0),
        ------------- Transmit Ports - TX Initialization and Reset Ports -----------
        GT0_TXRESETDONE_OUT             => SFP_txresetdone(0),
        ------------------ Transmit Ports - pattern Generator Ports ----------------
        GT0_TXPRBSSEL_IN                => SFP_TXPRBSSEL_IN(0),


  
 
 
 
        --_____________________________________________________________________
        --_____________________________________________________________________
        --GT1  (X1Y13)

        ---------------------------- Channel - DRP Ports  --------------------------
        GT1_DRPADDR_IN                  => SFP_drpaddr(1),
        GT1_DRPCLK_IN                   => DRPclk,
        GT1_DRPDI_IN                    => SFP_drpdi(1),
        GT1_DRPDO_OUT                   => SFP_drpdo(1),
        GT1_DRPEN_IN                    => SFP_drpen(1),
        GT1_DRPRDY_OUT                  => SFP_drprdy(1),
        GT1_DRPWE_IN                    => SFP_drpwe(1),
        ------------------------------- Loopback Ports -----------------------------
        GT1_LOOPBACK_IN                 => SFP_LOOPBACK_IN(1),
        --------------------- RX Initialization and Reset Ports --------------------
        GT1_RXUSERRDY_IN                => SFP_rxuserrdy(1),
        -------------------------- RX Margin Analysis Ports ------------------------
        GT1_EYESCANDATAERROR_OUT        => SFP_EYESCANDATAERROR_OUT(1),
        ------------------------- Receive Ports - CDR Ports ------------------------
        GT1_RXCDRLOCK_OUT               =>      open,
        ------------------ Receive Ports - FPGA RX Interface Ports -----------------
        GT1_RXUSRCLK_IN                 => SFP_RXUSRCLK(1),
        GT1_RXUSRCLK2_IN                => SFP_RXUSRCLK(1),
        ------------------ Receive Ports - FPGA RX interface Ports -----------------
        GT1_RXDATA_OUT                  => SFP_RXD_inv(1),
        ------------------- Receive Ports - Pattern Checker Ports ------------------
        GT1_RXPRBSERR_OUT               => SFP_RXPRBSERR_OUT(1),
        GT1_RXPRBSSEL_IN                => SFP_RXPRBSSEL_IN(1),
        ------------------- Receive Ports - Pattern Checker ports ------------------
        GT1_RXPRBSCNTRESET_IN           =>      '0',
        --------------------------- Receive Ports - RX AFE -------------------------
        GT1_GTXRXP_IN                   => SFP1_RXP,
        ------------------------ Receive Ports - RX AFE Ports ----------------------
        GT1_GTXRXN_IN                   => SFP1_RXN,
        ------------------- Receive Ports - RX Buffer Bypass Ports -----------------
        GT1_RXBUFRESET_IN               => '0',
        GT1_RXBUFSTATUS_OUT             => open,
        --------------- Receive Ports - RX Fabric Output Control Ports -------------
        GT1_RXOUTCLK_OUT                => SFP_rxoutclk(1),
        ---------------------- Receive Ports - RX Gearbox Ports --------------------
        GT1_RXDATAVALID_OUT             => SFP_RXDVLD(1),
        GT1_RXHEADER_OUT                => SFP_RXHEADER(1),
        GT1_RXHEADERVALID_OUT           => SFP_RXHEADERVLD(1),
        --------------------- Receive Ports - RX Gearbox Ports  --------------------
        GT1_RXGEARBOXSLIP_IN            => SFP_RXGEARBOXSLIP(1),
        ------------- Receive Ports - RX Initialization and Reset Ports ------------
        GT1_GTRXRESET_IN                => SFP_gtrxreset(1),
        GT1_RXPMARESET_IN               => '0',
        ------------------ Receive Ports - RX Margin Analysis ports ----------------
        GT1_RXLPMEN_IN                  => '0',
        -------------- Receive Ports -RX Initialization and Reset Ports ------------
        GT1_RXRESETDONE_OUT             => SFP_rxresetdone(1),
        ------------------------ TX Configurable Driver Ports ----------------------
        GT1_TXPOSTCURSOR_IN             => (others => '0'),
        GT1_TXPRECURSOR_IN              => (others => '0'),
        --------------------- TX Initialization and Reset Ports --------------------
        GT1_GTTXRESET_IN                => SFP_gttxreset(1),
        GT1_TXUSERRDY_IN                => SFP_txuserrdy(1),
        ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
        GT1_TXUSRCLK_IN                 => txusrclk,
        GT1_TXUSRCLK2_IN                => txusrclk,
        --------------- Transmit Ports - TX Configurable Driver Ports --------------
        GT1_TXDIFFCTRL_IN               => "1110",
        GT1_TXINHIBIT_IN                => '0',
        GT1_TXMAINCURSOR_IN             => (others => '0'),
        ------------------ Transmit Ports - TX Data Path interface -----------------
        GT1_TXDATA_IN                   => SFP_TXD_inv(1),
        ---------------- Transmit Ports - TX Driver and OOB signaling --------------
        GT1_GTXTXN_OUT                  => SFP1_TXN,
        GT1_GTXTXP_OUT                  => SFP1_TXP,
        ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
        GT1_TXOUTCLK_OUT                => open,
        GT1_TXOUTCLKFABRIC_OUT          => open,
        GT1_TXOUTCLKPCS_OUT             => open,
        --------------------- Transmit Ports - TX Gearbox Ports --------------------
        GT1_TXHEADER_IN                 => SFP_TXHEADER(1),
        GT1_TXSEQUENCE_IN               => SFP_TXSEQUENCE(1),
        ------------- Transmit Ports - TX Initialization and Reset Ports -----------
        GT1_TXRESETDONE_OUT             => SFP_txresetdone(1),
        ------------------ Transmit Ports - pattern Generator Ports ----------------
        GT1_TXPRBSSEL_IN                => SFP_TXPRBSSEL_IN(1),


  
 
 
 
        --_____________________________________________________________________
        --_____________________________________________________________________
        --GT2  (X1Y14)

        ---------------------------- Channel - DRP Ports  --------------------------
        GT2_DRPADDR_IN                  => SFP_drpaddr(2),
        GT2_DRPCLK_IN                   => DRPclk,
        GT2_DRPDI_IN                    => SFP_drpdi(2),
        GT2_DRPDO_OUT                   => SFP_drpdo(2),
        GT2_DRPEN_IN                    => SFP_drpen(2),
        GT2_DRPRDY_OUT                  => SFP_drprdy(2),
        GT2_DRPWE_IN                    => SFP_drpwe(2),
        ------------------------------- Loopback Ports -----------------------------
        GT2_LOOPBACK_IN                 => SFP_LOOPBACK_IN(2),
        --------------------- RX Initialization and Reset Ports --------------------
        GT2_RXUSERRDY_IN                => SFP_rxuserrdy(2),
        -------------------------- RX Margin Analysis Ports ------------------------
        GT2_EYESCANDATAERROR_OUT        => SFP_EYESCANDATAERROR_OUT(2),
        ------------------------- Receive Ports - CDR Ports ------------------------
        GT2_RXCDRLOCK_OUT               =>      open,
        ------------------ Receive Ports - FPGA RX Interface Ports -----------------
        GT2_RXUSRCLK_IN                 => SFP_RXUSRCLK(2),
        GT2_RXUSRCLK2_IN                => SFP_RXUSRCLK(2),
        ------------------ Receive Ports - FPGA RX interface Ports -----------------
        GT2_RXDATA_OUT                  => SFP_RXD_inv(2),
        ------------------- Receive Ports - Pattern Checker Ports ------------------
        GT2_RXPRBSERR_OUT               => SFP_RXPRBSERR_OUT(2),
        GT2_RXPRBSSEL_IN                => SFP_RXPRBSSEL_IN(2),
        ------------------- Receive Ports - Pattern Checker ports ------------------
        GT2_RXPRBSCNTRESET_IN           =>      '0',
        --------------------------- Receive Ports - RX AFE -------------------------
        GT2_GTXRXP_IN                   => SFP2_RXP,
        ------------------------ Receive Ports - RX AFE Ports ----------------------
        GT2_GTXRXN_IN                   => SFP2_RXN,
        ------------------- Receive Ports - RX Buffer Bypass Ports -----------------
        GT2_RXBUFRESET_IN               => '0',
        GT2_RXBUFSTATUS_OUT             => open,
        --------------- Receive Ports - RX Fabric Output Control Ports -------------
        GT2_RXOUTCLK_OUT                => SFP_rxoutclk(2),
        ---------------------- Receive Ports - RX Gearbox Ports --------------------
        GT2_RXDATAVALID_OUT             => SFP_RXDVLD(2),
        GT2_RXHEADER_OUT                => SFP_RXHEADER(2),
        GT2_RXHEADERVALID_OUT           => SFP_RXHEADERVLD(2),
        --------------------- Receive Ports - RX Gearbox Ports  --------------------
        GT2_RXGEARBOXSLIP_IN            => SFP_RXGEARBOXSLIP(2),
        ------------- Receive Ports - RX Initialization and Reset Ports ------------
        GT2_GTRXRESET_IN                => SFP_gtrxreset(2),
        GT2_RXPMARESET_IN               => '0',
        ------------------ Receive Ports - RX Margin Analysis ports ----------------
        GT2_RXLPMEN_IN                  => '0',
        -------------- Receive Ports -RX Initialization and Reset Ports ------------
        GT2_RXRESETDONE_OUT             => SFP_rxresetdone(2),
        ------------------------ TX Configurable Driver Ports ----------------------
        GT2_TXPOSTCURSOR_IN             => (others => '0'),
        GT2_TXPRECURSOR_IN              => (others => '0'),
        --------------------- TX Initialization and Reset Ports --------------------
        GT2_GTTXRESET_IN                => SFP_gttxreset(2),
        GT2_TXUSERRDY_IN                => SFP_txuserrdy(2),
        ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
        GT2_TXUSRCLK_IN                 => txusrclk,
        GT2_TXUSRCLK2_IN                => txusrclk,
        --------------- Transmit Ports - TX Configurable Driver Ports --------------
        GT2_TXDIFFCTRL_IN               => "1110",
        GT2_TXINHIBIT_IN                => '0',
        GT2_TXMAINCURSOR_IN             => (others => '0'),
        ------------------ Transmit Ports - TX Data Path interface -----------------
        GT2_TXDATA_IN                   => SFP_TXD_inv(2),
        ---------------- Transmit Ports - TX Driver and OOB signaling --------------
        GT2_GTXTXN_OUT                  => SFP2_TXN,
        GT2_GTXTXP_OUT                  => SFP2_TXP,
        ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
        GT2_TXOUTCLK_OUT                => open,
        GT2_TXOUTCLKFABRIC_OUT          => open,
        GT2_TXOUTCLKPCS_OUT             => open,
        --------------------- Transmit Ports - TX Gearbox Ports --------------------
        GT2_TXHEADER_IN                 => SFP_TXHEADER(2),
        GT2_TXSEQUENCE_IN               => SFP_TXSEQUENCE(2),
        ------------- Transmit Ports - TX Initialization and Reset Ports -----------
        GT2_TXRESETDONE_OUT             => SFP_txresetdone(2),
        ------------------ Transmit Ports - pattern Generator Ports ----------------
        GT2_TXPRBSSEL_IN                => SFP_TXPRBSSEL_IN(2),




    --____________________________COMMON PORTS________________________________
        ---------------------- Common Block  - Ref Clock Ports ---------------------
        GT0_GTREFCLK0_COMMON_IN         => REFCLK,
        ------------------------- Common Block - QPLL Ports ------------------------
        GT0_QPLLLOCK_OUT                => qplllock,
        GT0_QPLLLOCKDETCLK_IN           => DRPclk,
        GT0_QPLLRESET_IN                => qpllreset

    );
process(SFP_TXD,SFP_RXD,SFP_RXD_inv)
	begin
		for j in 0 to 2 loop
			for i in 0 to 31 loop
				SFP_TXD_inv(j)(i) <= SFP_TXD(j)(31-i);
				SFP_RXD(j)(i) <= SFP_RXD_inv(j)(31-i);
			end loop;
		end loop;
end process;
i_REFCLK : IBUFDS_GTE2 port map(O => REFCLK, ODIV2 => open, CEB => '0', I => SFP_REFCLK_P, IB => SFP_REFCLK_N);
i_txusrclk : BUFG port map (I => SFP_TXOUTCLK(0), O => txusrclk);
g_SFP_rxusrclk : for i in 0 to 2 generate
	i_SFP_rxusrclk : BUFG port map (I => SFP_RXOUTCLK(i), O => SFP_rxusrclk(i));
end generate;
i_REFCLK2X_in: bufg port map(i => REFCLK, o => REFCLK2X_in);
i_ClientClk2X : BUFG port map (I => ClientClk2X_dcm, O => ClientClk2X);
i_ClientClk : BUFG port map (I => ClientClk_dcm, O => ClientClk);
i_REFCLK2XPLLRST : SRL16 generic map(INIT => x"ffff")
   port map (
      Q => REFCLK2XPLLRST,       -- SRL data output
      A0 => '1',     -- Select[0] input
      A1 => '1',     -- Select[1] input
      A2 => '1',     -- Select[2] input
      A3 => '1',     -- Select[3] input
      CLK => REFCLK2X_in,   -- Clock input
      D => '0'        -- SRL data input
   );
i_REFCLK2XPLL : PLLE2_BASE
   generic map (
      BANDWIDTH => "OPTIMIZED",  -- OPTIMIZED, HIGH, LOW
      CLKFBOUT_MULT => 8,        -- Multiply value for all CLKOUT, (2-64)
      CLKFBOUT_PHASE => 0.0,     -- Phase offset in degrees of CLKFB, (-360.000-360.000).
      CLKIN1_PERIOD => 6.4,      -- Input clock period in ns to ps resolution (i.e. 33.333 is 30 MHz).
      -- CLKOUT0_DIVIDE - CLKOUT5_DIVIDE: Divide amount for each CLKOUT (1-128)
      CLKOUT0_DIVIDE => 4,
      DIVCLK_DIVIDE => 1,        -- Master division value, (1-56)
      REF_JITTER1 => 0.0,        -- Reference input jitter in UI, (0.000-0.999).
      STARTUP_WAIT => "FALSE"    -- Delay DONE until PLL Locks, ("TRUE"/"FALSE")
   )
   port map (
      -- Clock Outputs: 1-bit (each) output: User configurable clock outputs
      CLKOUT0 => ClientClk2X_dcm,
     -- Feedback Clocks: 1-bit (each) output: Clock feedback ports
      CLKFBOUT => ClientClk_dcm, -- 1-bit output: Feedback clock
      -- Status Port: 1-bit (each) output: PLL status ports
      LOCKED => ClientClk_lock,     -- 1-bit output: LOCK
      -- Clock Input: 1-bit (each) input: Clock input
      CLKIN1 => REFCLK2X_in,     -- 1-bit input: Input clock
      -- Control Ports: 1-bit (each) input: PLL control ports
      PWRDWN => '0',     -- 1-bit input: Power-down
      RST => REFCLK2XPLLRST,           -- 1-bit input: Reset
      -- Feedback Clocks: 1-bit (each) input: Clock feedback ports
      CLKFBIN => ClientClk    -- 1-bit input: Feedback clock
   );
process(ipb_addr)
variable s : std_logic_vector(1 downto 0);
begin
	case ipb_addr(11 downto 10) is
		when "00" =>
			case enSFP(2 downto 0) is
				when "010" | "011" | "101" | "111" => s := "01";
				when "110" => s := "10";
				when others => s := "00";
			end case;
		when "01" =>
			case enSFP(2 downto 0) is
				when "010" | "011" | "111" => s := "00";
				when "101" => s := "10";
				when others => s := "01";
			end case;
		when "10" =>
			case enSFP(2 downto 0) is
				when "100" | "101" | "110" => s := "00";
				when others => s := "10";
			end case;
		when others => s := "11";
	end case;
	if(ipb_addr(15 downto 12) = x"1")then
		case s is
--			case ipb_addr(11 downto 10) is
			when "00" => ipb_rdata <= TCPIP_rdata(0);
			when "01" => ipb_rdata <= TCPIP_rdata(1);
			when "10" => ipb_rdata <= TCPIP_rdata(2);
			when others =>
				case ipb_addr(4 downto 0) is
					when "00000" => ipb_rdata <= x"0" & NXT_MonBuf(1) & x"0" & NXT_MonBuf(0);
					when "00001" => ipb_rdata <= x"0000" & x"0" & NXT_MonBuf(2);
					when "00010" => ipb_rdata <= "000" & UNA_MonBuf(1) & "000" & UNA_MonBuf(0);
					when "00011" => ipb_rdata <= "000" & UNA_MonBuf(3) & "000" & UNA_MonBuf(2);
					when "00100" => ipb_rdata <= x"0000" & "000" & UNA_MonBuf(4);
					when "00101" => ipb_rdata <= x"0" & NXT_TCPBuf(1) & x"0" & NXT_TCPBuf(0);
					when "00110" => ipb_rdata <= x"00000" & NXT_TCPBuf(2);
					when "00111" => ipb_rdata <= "000" & UNA_TCPBuf(1) & "000" & UNA_TCPBuf(0);
					when "01000" => ipb_rdata <= "000" & UNA_TCPBuf(3) & "000" & UNA_TCPBuf(2);
					when "01001" => ipb_rdata <= "000" & TCPBufCnt & "000" & MonBufCnt;
					when "01010" => ipb_rdata <= "000000" & AddrOffset(1) & "000000" & AddrOffset(0);
					when "01011" => ipb_rdata <= x"00000" & "00" & AddrOffset(2);
					when "01100" => ipb_rdata <= x"0" & LAST_MonBuf(1) & x"0" & LAST_MonBuf(0);
					when "01101" => ipb_rdata <= '0' & ReadBusy & LAST_MonBuf(3) & x"0" & LAST_MonBuf(2);
					when "01110" => ipb_rdata <= x"000" & SFP2TCPIP(2) & SFP2TCPIP(1) & SFP2TCPIP(0) & TCPIP2SFP_sel(2) & TCPIP2SFP_sel(1) & TCPIP2SFP_sel(0) & '0' & EnTCPIP & '0' & LINK_down;
--						when "01111" => ipb_rdata <= x"0000" & "000" & TCPAddrOffset(2);
					when "10000" => ipb_rdata <= '0' & RETX_ddr_rrqst & '0' & RETX_ddr_wrqst & '0' & EVENTdata_avl & '0' & AddrBuf_full & '0' & evt_FIFO_full & '0' & wport_FIFO_full & '0' & wport_rdy & '0' & evt_data_rdy;
					when "10001" => ipb_rdata <= "000" & TCP_rFIFO_ra & "000" & TCP_rFIFO_wa & TCP_rrqst_i & rrqst & rrqstMask  & '0' & RETXdataAck & '0' & RETXdataRqst;
					when "10010" => ipb_rdata <= '0' & TCP_wFIFO_busy & TCP_wFIFO_EMPTY & TCP_wFIFO_FULL & '0' & rdDDRqueue_dout & '0' & rdDDRqueue_a & RETX_ddr_rp_a & RETX_ddr_rp_do;
					when "11100" => ipb_rdata <= SFP_IPADDR(0);
					when "11101" => ipb_rdata <= SFP_IPADDR(1);
					when "11110" => ipb_rdata <= SFP_IPADDR(2);
					when "11111" => ipb_rdata <= CWND_max;
					when others => ipb_rdata <= (others => '0');
				end case;
		end case;
	else
		ipb_rdata <= (others => '0');
	end if;
end process;
process(ipb_clk)
begin
	if(ipb_clk'event and ipb_clk = '1')then
		if(ipb_addr(27) = '0' and ipb_addr(15 downto 2) = "00011100000111" and ipb_strobe = '1' and ipb_write = '1')then
			if(ipb_addr(1 downto 0) = "11")then
				CWND_max <= ipb_wdata;
			else
				SFP_IPADDR(conv_integer(ipb_addr(1 downto 0))) <= ipb_wdata;
			end if;
		end if;
		if(ipb_addr(27) = '0' and ipb_addr(15 downto 12) = x"1")then
			ipb_ack <= ipb_strobe;
		else
			ipb_ack <= '0';
		end if;
	end if;
end process;
end Behavioral;

