----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    09:47:17 10/04/2013 
-- Design Name: 
-- Module Name:    TCP_CC - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use IEEE.std_logic_misc.all;
use IEEE.numeric_std.all;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity TCP_CC is
    Port ( clk : in  STD_LOGIC;
					 reset : in  STD_LOGIC;
					 RETX_TO : in  STD_LOGIC;
					 FastReTxStart : in  STD_LOGIC;
					 FR : in  STD_LOGIC;
					 PartialACK : in  STD_LOGIC;
					 NewDataACK : in  STD_LOGIC;
					 DupACK : in  STD_LOGIC;
           MSS : in  STD_LOGIC_VECTOR (15 downto 0);
           CWND_max : in  STD_LOGIC_VECTOR (31 downto 0);
           SND_UNA : in  STD_LOGIC_VECTOR (31 downto 0);
           SND_NXT : in  STD_LOGIC_VECTOR (31 downto 0);
           CWND : out  STD_LOGIC_VECTOR (31 downto 0);
           debug : out  STD_LOGIC_VECTOR (271 downto 0)
					 );
end TCP_CC;

architecture Behavioral of TCP_CC is
signal SND_UNA_OLD : std_logic_vector(31 downto 0) := (others => '0');
signal DataACKed : std_logic_vector(31 downto 0) := (others => '0');
signal DataACKedSUM : std_logic_vector(31 downto 0) := (others => '0');
signal MSSx2 : std_logic_vector(31 downto 0) := (others => '0');
signal MSSx3 : std_logic_vector(31 downto 0) := (others => '0');
signal CWND_i : std_logic_vector(31 downto 0) := (others => '0');
signal CWND_INC : std_logic_vector(31 downto 0) := (others => '0');
signal CWND_FAST : std_logic_vector(31 downto 0) := (others => '0');
signal SSTHRESH : std_logic_vector(31 downto 0) := (others => '0');
signal CWND_sub_SSTHRESH : std_logic_vector(31 downto 0) := (others => '0');
signal FLIGHT_SIZE : std_logic_vector(31 downto 0) := (others => '0');
signal FLIGHT_SIZEplusMSS : std_logic_vector(31 downto 0) := (others => '0');
signal SSTHRESH_RETX : std_logic_vector(31 downto 0) := (others => '0');
signal New_TO : std_logic := '0';
signal SS : std_logic := '0';
signal CA : std_logic := '0';
--signal FR : std_logic := '0';
signal PartACK : std_logic := '0';
signal NewDataACK_dl : std_logic_vector(1 downto 0) := (others => '0');
signal DataACKedSUM_GT_CWND : std_logic := '0';

begin
debug(263 downto 232) <= FLIGHT_SIZE;
debug(231 downto 200) <= SSTHRESH;
debug(199 downto 168) <= CWND_FAST;
debug(167 downto 136) <= CWND_INC;
debug(127 downto 96) <= CWND_i;
debug(95 downto 64) <= DataACKedSUM;
debug(63) <= DupACK;
debug(62) <= PartialACK ;
debug(61) <= FastReTxStart;
--debug(60) <= inh_FastReTx;
debug(59) <= New_TO;
debug(58) <= RETX_TO;
debug(57) <= NewDataACK;
debug(56) <= DataACKedSUM_GT_CWND;
debug(55) <= PartACK;
debug(54) <= FR;
debug(53) <= CA;
debug(52) <= SS;
debug(51 downto 32) <= DataACKed(19 downto 0);
debug(31 downto 0) <= SND_UNA;
MSSx2 <= x"0000" & MSS(14 downto 0) & '0';
process(clk)
begin
	if(clk'event and clk = '1')then
		if(CWND_i(31 downto 30) /= "00")then
			CWND <= x"3fffffff";
		elsif(CWND_i > CWND_max)then
			CWND <= CWND_max;
		else
			CWND <= CWND_i;
		end if;
		SND_UNA_OLD <= SND_UNA;
		DataACKed <= SND_UNA - SND_UNA_OLD;
		NewDataACK_dl <= NewDataACK_dl(0) & NewDataACK;
		if(CA = '0' or DataACKedSUM_GT_CWND = '1')then
			DataACKedSUM <= (others => '0');
		elsif(NewDataACK_dl(0) = '1')then
			DataACKedSUM <= DataACKedSUM + DataACKed;
		end if;
		if(CA = '1' and DataACKedSUM > CWND_i and NewDataACK_dl(1) = '1')then
			DataACKedSUM_GT_CWND <= '1';
		else
			DataACKedSUM_GT_CWND <= '0';
		end if;
		if((or_reduce(DataACKed(31 downto 16)) = '1' or DataACKed(15 downto 0) >= MSS) and FR = '1' and NewDataACK_dl(0) = '1' and PartialACK = '1')then
			PartACK <= '1';
		else
			PartACK <= '0';
		end if;
		if(SS = '1' and or_reduce(DataACKed(31 downto 16)) = '0' and DataACKed(15 downto 0) < MSS)then
			CWND_INC(15 downto 0) <= DataACKed(15 downto 0);
		else
			CWND_INC(15 downto 0) <= MSS;
		end if;
		CWND_sub_SSTHRESH <= CWND_i - SSTHRESH;
		if(reset = '1')then
			CWND_i <= MSSx2;
		elsif(RETX_TO = '1')then
			CWND_i <= x"0000" & MSS;
		elsif(FastReTxStart = '1' or (FR = '1' and NewDataACK = '1' and PartialACK = '0'))then
			CWND_i <= CWND_FAST;
		elsif(FR = '1' and NewDataACK_dl(0) = '1' and PartialACK = '1')then
			if(CWND_sub_SSTHRESH > DataACKed)then
				CWND_i <= CWND_i - DataACKed;
			else
				CWND_i <= SSTHRESH;
			end if;
		elsif(CWND_i(31) = '0' and ((SS = '1' and NewDataACK_dl(1) = '1') or DataACKedSUM_GT_CWND = '1' or (FR = '1' and DupACK = '1') or PartACK = '1'))then
			CWND_i <= CWND_i + CWND_INC;
		end if;
		MSSx3 <= MSSx2 + (x"0000" & MSS);
		if(FR = '0')then
			CWND_FAST <= SSTHRESH + MSSx3;
		elsif(FLIGHT_SIZEplusMSS > SSTHRESH)then
			CWND_FAST <= SSTHRESH;
		else
			CWND_FAST <= FLIGHT_SIZEplusMSS; -- this is MSS added by the flight size before the NewDataACK arrives
		end if;
		if(FR = '1')then
			SS <= '0';
			CA <= '0';
		elsif(CWND_i > SSTHRESH)then
			SS <= '0';
			CA <= '1';
		else
			SS <= '1';
			CA <= '0';
		end if;
		if(reset = '1' or NewDataACK = '1')then
			New_TO <= '1';
		elsif(RETX_TO = '1')then
			New_TO <= '0';
		end if;
		if(reset = '1')then
			SSTHRESH <= x"3fffffff";
		elsif((RETX_TO = '1' and New_TO = '1') or FastReTxStart = '1')then
			SSTHRESH <= SSTHRESH_RETX;
		end if;
		FLIGHT_SIZE <= SND_NXT - SND_UNA;
		FLIGHT_SIZEplusMSS <= FLIGHT_SIZE + (x"0000" & MSS);
		if(FLIGHT_SIZE(31 downto 1) > MSSx2(30 downto 0))then
			SSTHRESH_RETX <= '0' & FLIGHT_SIZE(31 downto 1);
		else
			SSTHRESH_RETX <= MSSx2;
		end if;
--		if((NewDataACK = '1' and PartialACK = '0') or ReTx_TO = '1')then
--			FR <= '0';
--		elsif(FastReTxStart = '1')then
--			FR <= '1';
--		end if;
	end if;
end process;

end Behavioral;

