----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    13:09:26 05/16/2012 
-- Design Name: 
-- Module Name:    fake_event - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use IEEE.std_logic_misc.all;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
library UNISIM;
use UNISIM.VComponents.all;

entity fake_event is
    Port (
           sysclk : in  STD_LOGIC;
           UsrClk : in  STD_LOGIC;
           reset : in  STD_LOGIC;
           fake_en : in  STD_LOGIC;
           ovfl_warning : in  STD_LOGIC;
					 fake_length	: in   std_logic_vector(11 downto 0);
           LinkFull : in  STD_LOGIC;
					 L1A_DATA	: in   std_logic_vector(15 downto 0);
					 L1A_WrEn : in   std_logic;
           fake_header : out  STD_LOGIC;
           fake_accept : out  STD_LOGIC;
           empty_event_flag : out  STD_LOGIC;
           fake_DATA : out  STD_LOGIC_VECTOR (15 downto 0);
           fake_WrEn : out  STD_LOGIC
					 );
end fake_event;

architecture Behavioral of fake_event is
component crc16D16
    Port ( clk : in std_logic;
           init_crc : in std_logic;
           we_crc : in std_logic;
           d : in std_logic_vector(15 downto 0);
           crc : out std_logic_vector(15 downto 0));
end component;
signal L1A_infoDi : std_logic_vector(31 downto 0) := (others => '0');
signal L1A_infoDo : std_logic_vector(31 downto 0) := (others => '0');
signal L1A_info_RdEn : std_logic := '0';
signal L1A_info_WrEn : std_logic := '0';
signal L1A_info_Empty : std_logic := '0';
signal L1A_info_avl : std_logic_vector(2 downto 0) := (others => '0');
signal ovfl_warning_sync : std_logic_vector(3 downto 0) := (others =>'0');
signal empty_event : std_logic := '0';
signal fifo_en : std_logic := '0';
signal fifo_rst : std_logic := '0';
signal reset_dl : std_logic := '0';
signal reset_dl2 : std_logic := '0';
signal data_valid : std_logic := '0';
signal data_header : std_logic := '0';
signal data_trailer : std_logic := '0';
signal data_trailer_dl : std_logic := '0';
signal data : std_logic_vector(15 downto 0) := (others => '0');
signal data_wc : std_logic_vector(11 downto 0) := (others => '0');
signal payload_wc : std_logic_vector(11 downto 0) := (others => '0');
signal event_length : std_logic_vector(11 downto 0) := (others => '0');
signal trailer : std_logic_vector(15 downto 0) := (others => '0');
signal ec_data_wc : std_logic := '0';
signal ec_data_wc_q : std_logic := '0';
signal init_crc : std_logic := '0';
signal we_crc : std_logic := '0';
signal CRC : std_logic_vector(15 downto 0) := (others => '0');
--signal EventBuiltCntr : std_logic_vector(3 downto 0) := (others => '0');
--signal EventBuiltCntrSync : std_logic_vector(3 downto 0) := (others => '0');
--signal EventBuiltCntrSync2 : std_logic_vector(3 downto 0) := (others => '0');
--signal EventBuiltCntrBin : std_logic_vector(3 downto 0) := (others => '0');
--signal EventSentCntr : std_logic_vector(3 downto 0) := (others => '0');
--signal EventInSlink : std_logic_vector(3 downto 0) := (others => '0');
begin
fake_header <= data_header;
fake_WrEn <= data_valid;
empty_event_flag <= empty_event;
i_fake_accept : SRL16E
   port map (
      Q => fake_accept,       -- SRL data output
      A0 => '1',     -- Select[0] input
      A1 => '0',     -- Select[1] input
      A2 => '0',     -- Select[2] input
      A3 => '0',     -- Select[3] input
      CE => '1',     -- Clock enable input
      CLK => UsrClk,   -- Clock input
      D => data_trailer        -- SRL data input
   );
i_fifo_rst : SRL16E
   generic map (
      INIT => X"0000")
   port map (
      Q => fifo_rst,       -- SRL data output
      A0 => '1',     -- Select[0] input
      A1 => '1',     -- Select[1] input
      A2 => '1',     -- Select[2] input
      A3 => '0',     -- Select[3] input
      CE => '1',     -- Clock enable input
      CLK => sysclk,   -- Clock input
      D => reset        -- SRL data input
   );
i_reset_dl : SRL16E
   generic map (
      INIT => X"0000")
   port map (
      Q => reset_dl,       -- SRL data output
      A0 => '1',     -- Select[0] input
      A1 => '1',     -- Select[1] input
      A2 => '1',     -- Select[2] input
      A3 => '0',     -- Select[3] input
      CE => '1',     -- Clock enable input
      CLK => sysclk,   -- Clock input
      D => fifo_rst        -- SRL data input
   );
process(sysclk)
begin
	if(sysclk'event and sysclk = '1')then
		if(reset = '1')then
			fifo_en <= '0';
		elsif(reset_dl = '0' and reset_dl2 = '1')then
			fifo_en <= '1';
		end if;
		reset_dl2 <= reset_dl;
--		if(reset = '1')then
--			EventBuiltCntr <= x"0";
--		elsif(EventBuilt = '1')then
--			case EventBuiltCntr is
--				when x"0" => EventBuiltCntr <= x"1";
--				when x"1" => EventBuiltCntr <= x"3";
--				when x"2" => EventBuiltCntr <= x"6";
--				when x"3" => EventBuiltCntr <= x"2";
--				when x"4" => EventBuiltCntr <= x"c";
--				when x"5" => EventBuiltCntr <= x"4";
--				when x"6" => EventBuiltCntr <= x"7";
--				when x"7" => EventBuiltCntr <= x"5";
--				when x"8" => EventBuiltCntr <= x"0";
--				when x"9" => EventBuiltCntr <= x"8";
--				when x"a" => EventBuiltCntr <= x"b";
--				when x"b" => EventBuiltCntr <= x"9";
--				when x"c" => EventBuiltCntr <= x"d";
--				when x"d" => EventBuiltCntr <= x"f";
--				when x"e" => EventBuiltCntr <= x"a";
--				when others => EventBuiltCntr <= x"e";
--			end case;
--		end if;
	end if;
end process;
i_L1A_info : FIFO18E1
   generic map (
      ALMOST_EMPTY_OFFSET => X"0080",   -- Sets the almost empty threshold
      ALMOST_FULL_OFFSET => X"0080",    -- Sets almost full threshold
      DATA_WIDTH => 18,                  -- Sets data width to 4, 9, 18, or 36
      DO_REG => 1,                      -- Enable output register (0 or 1) Must be 1 if EN_SYN = FALSE
      EN_SYN => FALSE,                  -- Specifies FIFO as dual-clock (FALSE) or Synchronous (TRUE)
      FIFO_MODE => "FIFO18",            -- Sets mode to FIFO18 or FIFO18_36
      FIRST_WORD_FALL_THROUGH => TRUE, -- Sets the FIFO FWFT to TRUE or FALSE
      INIT => X"000000000",             -- Initial values on output port
      SIM_DEVICE => "7SERIES",          -- Must be set to "7SERIES" for simulation behavior
      SRVAL => X"000000000"             -- Set/Reset value for output port
   )
   port map (
      -- Read Data: 32-bit (each) output: Read output data
      DO => L1A_infoDo,                   -- 32-bit output: data output
      DOP => open,                 -- 4-bit output: parity data output
      -- Status: 1-bit (each) output: Flags and other FIFO status outputs
      ALMOSTEMPTY => open, -- 1-bit output: almost empty output flag
      ALMOSTFULL => open,   -- 1-bit output: almost full output flag
      EMPTY => L1A_info_Empty,             -- 1-bit output: empty output flag
      FULL => open,               -- 1-bit output: full output flag
      RDCOUNT => open,         -- 12-bit output: read count output
      RDERR => open,             -- 1-bit output: read error output
      WRCOUNT => open,         -- 12-bit output: write count output
      WRERR => open,             -- 1-bit output: write error
      -- Read Control Signals: 1-bit (each) input: Read clock, enable and reset input signals
      RDCLK => UsrClk,             -- 1-bit input: read clock input
      RDEN => L1A_info_RdEn,               -- 1-bit input: read enable input
      REGCE => '1',             -- 1-bit input: clock enable input
      RST => fifo_rst,                 -- 1-bit input: reset input
      RSTREG => '0',           -- 1-bit input: output register set/reset
      -- Write Control Signals: 1-bit (each) input: Write clock and enable input signals
      WRCLK => sysclk,             -- 1-bit input: write clock input
      WREN => L1A_info_WrEn,               -- 1-bit input: write enable input
      -- Write Data: 32-bit (each) input: Write input data
      DI => L1A_infoDi,                   -- 32-bit input: data input
      DIP => x"0"                  -- 4-bit input: parity input
   );
L1A_infoDi <= x"0000" & L1A_Data;
L1A_info_RdEn <= '1' when fifo_en = '1' and ec_data_wc = '1' and (data_wc = x"000" or data_wc = x"001" or data_wc = x"003" or data_wc = x"004") else '0';
L1A_info_WrEn <= fifo_en and L1A_WrEn;
i_data_trailer_dl : SRL16E
   port map (
      Q => data_trailer_dl,       -- SRL data output
      A0 => '1',     -- Select[0] input
      A1 => '1',     -- Select[1] input
      A2 => '1',     -- Select[2] input
      A3 => '0',     -- Select[3] input
      CE => '1',     -- Clock enable input
      CLK => UsrClk,   -- Clock input
      D => data_trailer        -- SRL data input
   );
process(UsrClk)
begin
	if(UsrClk'event and UsrClk = '1')then
		ovfl_warning_sync <= ovfl_warning_sync(2 downto 0) & ovfl_warning;
		if(ec_data_wc_q = '0' and ec_data_wc = '1')then
			empty_event <= ovfl_warning_sync(3);
		end if;
		if(empty_event = '1')then
			event_length <= x"007";
			payload_wc <= x"000";
		else
			event_length <= fake_length + x"007";
			payload_wc <= fake_length;
		end if;
	end if;
end process;
process(UsrClk,reset)
begin
	if(reset = '1')then
		L1A_info_avl <= (others => '0');
		fake_DATA <= (others => '0');
		data <= (others => '0');
		trailer <= (others => '0');
		ec_data_wc <= '0';
		ec_data_wc_q <= '0';
		data_header <= '1';
		data_trailer <= '0';
		data_wc <= (others => '0');
		data_valid <= '0';
--		EventSentCntr <= (others => '0');
--		EventBuiltCntrSync <= (others => '0');
--		EventBuiltCntrSync2 <= (others => '0');
--		EventBuiltCntrBin <= (others => '0');
--		EventInSlink <= (others => '0');
	elsif(UsrClk'event and UsrClk = '1')then
		if(L1A_info_empty = '1')then
			L1A_info_avl <= (others => '0');
		elsif(L1A_info_avl(2) = '0')then
			L1A_info_avl <= L1A_info_avl + 1;
		end if;
		if(data_wc = event_length)then
			ec_data_wc <= '0';
		elsif(LinkFull = '0' and L1A_info_avl(2) = '1' and data_header = '1')then
			ec_data_wc <= '1';
		end if;
		if(ec_data_wc = '0')then
			data_wc <= (others => '0');
		else
			data_wc <= data_wc + 1;
		end if;
		if(ec_data_wc = '0' and ec_data_wc_q = '1')then
			data_trailer <= '1';
		else
			data_trailer <= '0';
		end if;
		if(data_trailer_dl = '1')then
			data_header <= '1';
		elsif(data_valid = '1')then
			data_header <= '0';
		end if;
		if(data_wc = x"000")then
			trailer <= L1A_infoDo(7 downto 0) & x"00";
		end if;
		if(data_wc = x"000")then
			data <= L1A_infoDo(15 downto 0);
		elsif(data_wc = x"001")then
			data <= L1A_infoDo(15 downto 0);
		elsif(data_wc = x"002")then
			data <= x"8000";
		elsif(data_wc = x"003")then
			data <= L1A_infoDo(15 downto 0);
		elsif(data_wc = x"004")then
			data <= x"8" & L1A_infoDo(11 downto 0);
		elsif(data_wc = x"005")then
			data <= x"0" & payload_wc;
		elsif(data_wc = event_length)then
			data <= trailer;
		else
			data <= x"0" & data_wc;
		end if;
		if(data_wc = event_length)then
			fake_DATA <= CRC;
		else
			fake_DATA <= data;
		end if;
		ec_data_wc_q <= ec_data_wc;
		data_valid <= we_crc;
--		if(data_trailer = '1')then
--			EventSentCntr <= EventSentCntr + 1;
--		end if;
--		EventBuiltCntrSync <= EventBuiltCntr;
--		EventBuiltCntrSync2 <= EventBuiltCntrSync;
--		EventBuiltCntrBin(3) <= EventBuiltCntrSync2(3);
--		EventBuiltCntrBin(2) <= EventBuiltCntrSync2(3) xor EventBuiltCntrSync2(2);
--		EventBuiltCntrBin(1) <= EventBuiltCntrSync2(3) xor EventBuiltCntrSync2(2) xor EventBuiltCntrSync2(1);
--		EventBuiltCntrBin(0) <= EventBuiltCntrSync2(3) xor EventBuiltCntrSync2(2) xor EventBuiltCntrSync2(1) xor EventBuiltCntrSync2(0);
--		EventInSlink <= EventSentCntr - EventBuiltCntrBin;
	end if;
end process;
i_CRC: crc16D16 PORT MAP(
		clk => UsrClk,
		init_crc => init_crc,
		we_crc => we_crc,
		d => data,
		crc => CRC
	);
we_crc <= ec_data_wc_q;
init_crc <= '1' when data_wc = x"001" else '0';
end Behavioral;

